/* ------------------------------------------------------ */
/*                  135-Kb RWC Non-Stop                   */
/*              (C) 1992 by OnMind Systems                */
/* ------------------------------------------------------ */

#include <stdio.h>
#include <alloc.h>
#include <process.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <time.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>

#define VOCSIZE ((unsigned long) 4*32*32*32 + 4*3*32*32 + 4*32 + 4)
#define BUFS 32767
#define PVAL(pp) (((unsigned long) *((unsigned *) &pp + 1)) << 4) + ((unsigned) pp)
#define PTRINC if (((unsigned) ptr) == 0xffff)\
                 *((unsigned *) &ptr + 1) += 0x1000;\
               ((unsigned) ptr) ++

FILE                     *f;
int                       vocf;
char huge                *vmax, *v2, *v3;
unsigned long huge       *vm, *v1;
char                     *buf, *pb;
union REGS                r;
char                     *s;
char                      w [35];
unsigned long             lcnt = 1;
short                     wrt = 0, noone = 0;
static char               vocname [12] = "MAIN.RWC";
char                      fname [77];
char                     *vocext = vocname + 5;
char                     textext [] = "TXT";
static char          voclabel [] = "RTC 3.1 DataFile (C) 1992 OMS";
time_t tim;
struct tm *timst;          /* Time variables */

/* ------------------------------------------------------ */

void back () { putchar ('\r'); clreol (); }

/* ------------------------------------------------------ */

void displ_help () {

  printf (
" This is RWC Non-Stop!\n\n"

"   Usage: NON-STOP [vocabulary] [-Ffilename]\n\n"

" Vocabulary: *.RWC (default vocabulary is MAIN).\n"
" If \"filename\" in the -F command is omitted,\n"
" the data-filename (e.g. 08-09-92.TXT) is constructed.\n\n"

" Additional information in file RWC.TXT");
  exit (0);
}

/* ------------------------------------------------------ */

void retype (char *name, char *ext) {

  char *p;

  while (((p = strrchr (name, '.')) == NULL) || *(p - 1) == '.')
    strcpy (name + strlen (name), ".");
  strcpy (++ p, ext);
}

/* ------------------------------------------------------*/

char *put_date (char *s) {

  time (&tim);
  timst = localtime (&tim);
  sprintf (s, "%02u%c%02u%c%02u",
    timst -> tm_mday, '-', timst -> tm_mon + 1, '-', timst -> tm_year);
  return (s);
}

/* ------------------------------------------------------ */

void cut_name (char *name, char *ext) {    /* Cut extra filename symbols */

  char *p;
  int l = 0;

  if (!*name) return;

  if (((p = strrchr (name, '.')) == NULL || *(p + 1) == '\\') && *ext)
                                                       /* If no extension, */
    retype (name, ext);                                /* set default */

  *(p + 4) = 0;                                        /* cut extension */

  if ((p = strrchr (name, '\\')) == NULL &&
      (p = strrchr (name, ':')) == NULL)
    p = name;
  else p ++;

  while (*p != '.' && *p != 0) {
    p ++;
    l ++;
  }

  if (l > 8)
    memmove (p - (l - 8), p, strlen (p) + 1);
}

/* ------------------------------------------------------ */

void kbcl (void) {

  *((unsigned far *) 0x41al) = *((unsigned far *) 0x41cl);
}

/* ------------------------------------------------------ */

int query () {

  r.h.ah = 1;
  int86 (0x16, &r, &r);
  if (!(r.x.flags & 0x40))
    return (r.h.al);
  return (-1);
}


/* ------------------------------------------------------ */

char getvoc (void) {

  if (pb - buf == BUFS)
    read (vocf, pb = buf, BUFS);
  return (*pb ++);
}

/* ------------------------------------------------------ */

void unarch (char *path) {

  register char        c;
  register unsigned long upto;
  char huge  *ptr;
  unsigned long next, crn;
  unsigned step;
  char pro = '1';

  vocf = open (path, O_RDONLY + O_BINARY);

  read (vocf, buf, 29);
  if (memcmp (buf, voclabel, 29)) {
    printf ("! NON-STOP: Bad vocabulary file: %s\n", path);
    exit (1);
  }

  lseek (vocf, 29, SEEK_SET);

  if ((vm = farmalloc (VOCSIZE)) == NULL) {
    puts ("! NON-STOP: Not enough memory");
    exit (1);
  }

  printf ("Loading vocabulary: 0% ");

   (char huge *)            v3 = (char huge *) (vm + 32768l);
   (char huge *)            v2 = (char huge *) (vm + 35840l);
   (unsigned long huge *)   v1 = (unsigned long huge *) (vm + 35872l);
  vmax = (char huge *) (v1 + 1);

  ptr  = (char huge *) vm;
  upto = PVAL(vmax);
  next = PVAL(vm) + (step = VOCSIZE / 10);

  while (c = getvoc (), (crn = PVAL(ptr)) < upto) {
    if (crn > next) {
      printf ("\b\b\b%c0%%", pro++);
      next += step;
    }
    if (c == 0xff)
      if ((c = getvoc ()) == 0xff)
        *ptr++ = 0xff;
      else {
        c++;
        *ptr = 0;
        PTRINC;
        while (c--) {
          *ptr = 0;
          PTRINC;
        }
      }
    else {
      *ptr = c;
      PTRINC;
      if (query () == 27) {
        back ();
        farfree ((void far *) vm);
        exit (0);
      }
      kbcl ();
    }
  }
  printf ("\b\b\b100%%");
  delay (20);
  back ();
}


/* ------------------------------------------------------ */

short isletter (char c) {

 return (
     ((c < 0xf2) && (c > 0xdf)
       ||
      (c < 0xb0) && (c > 0x7f)
     )
 );
}

/* ------------------------------------------------------ */

int isvowel (char *c) {

  switch (*c) {
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
      return (1);
    default:
      return (0);
  }
}

/* ------------------------------------------------------ */

int iscons (char *c) {

  if (isletter (*c) && ! isvowel (c))
    return (1);
  return (0);
}

/* ------------------------------------------------------ */

short cr (char c) {

  if ((c == 240) || (c == 241))
    return (5);

  if (c < 160)
    return (c - 128);
  else {
    if (c < 176)
      return (c - 160);
    else return (c - 208);
  }
}

/* ------------------------------------------------------ */

short letters (char *s, char l) {

  while (l --)
    if (!isletter (*(s + l)))
      return (0);
  return (1);
}
/* ------------------------------------------------------ */

unsigned long dw (char *c) {

  return((unsigned long) 1 << cr(*c));
}
/* ------------------------------------------------------ */

short rsmain (char *s) {

  auto unsigned long huge *ptr;

  if (isletter (*s) &&
      isletter (*(s+1)) &&
      isletter (*(s+2)) &&
      isletter (*(s+3))
     ) {
    ptr = vm + (((unsigned long) cr(*s)) << 10) +
               (((unsigned long) cr(*(s+1))) << 5) +
               ((unsigned long) cr(*(s+2))) ;
    return ((*ptr & dw (s + 3)) ? 1 : 0);
  }
  return (0);
}

/* ------------------------------------------------------ */

short rs1 (char *s) {

  if (isletter (*s)) {
    return (*v1 & dw (s) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs2 (char *s) {

  auto unsigned long far *ptr;

  if (isletter (*s) &&
      isletter (*(s+1))
     ) {
    ptr = (unsigned long far *)
      ((unsigned long) v2 + (((unsigned long) cr(*s)) << 2));
    return (*ptr & dw (s+1) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs3 (char *s, int ps) {

  auto unsigned long far *ptr;

  if (letters (s, 3)) {
    ptr = (unsigned long far *) (
              ((unsigned long) v3) +
             (((unsigned long) ps) << 12) +
             (((unsigned long) cr(*s)) << 7) +
             (((unsigned long) cr(*(s+1))) << 2));
    return (*ptr & dw (s+2) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

char randch () {

  char c;

  if ((c = ((char) rand () >> 3)) <= 15)
    return (c + 160);
  return (c + 208);

}

/* ------------------------------------------------------ */

char upc (char c) {

 if (c < 224)
   return (c - 32);
 return (c - 80);
}

/* ------------------------------------------------------ */

void wordgen (char l) {

  char pp, ch, chstart;
  int pause = -1;

b:
  if (query () == 27) {
    if (wrt) {
      fprintf (f, "%s\r\n", s);
      fclose (f);
    }
    farfree ((void far *) vm);
    lowvideo ();
    clreol ();
    exit (0);
  }
  if (query () == 32 || pause > 0 && query () != -1 && query () != 27) {
    pause = -pause;
    kbcl ();
  }
  if (pause > 0)
    goto b;
  kbcl ();

  do {
    w [0] = randch ();
    w [1] = randch ();
    w [2] = randch ();
    w [3] = randch ();
  } while (!rsmain (w) || !rs3 (w, 1));

  pp = 3;
  while (pp++ < l - 1) {
    ch = chstart = randch ();
loop:
    if (++ch > '')
      ch = '';
    if (ch == chstart)
      goto b;

      w [pp] = ch;
      if (rsmain (w + pp - 3))
        goto e;
      goto loop;
e:
    w [l] = 0;
  }
  if (!rs3 (w + l - 3, 2))
    goto b;
}

/* ------------------------------------------------------ */

void main (int argc, char **argv) {

  short beg = 1, abz = 0, help = 0;
  register char t;
  char c, l;
  char st [255];
  struct date dt;
  char voc [70];
  char *p;
  short pun, kon;

  *voc = 0;

  textcolor (LIGHTGRAY);
  textbackground (BLACK);
  printf ("\r  RWC Non-Stop, Version 1.0, Copyright (C) 1992 OnMind Systems\n\n");

  for (c = 1; c < argc; c ++) {
    if (**(argv + c) == '-') {
      switch (toupper (*(*(argv + c) + 1))) {
        case '?':
          help = 1;
        case 'F':
          wrt = 1;
          strcpy (fname, *(argv + c) + 2);
          break;
      }
    } else
      strcpy (voc, *(argv + c));
  }

  if (help)
    displ_help ();
  else
    printf ("   Type  NON-STOP -?  for help\n\n");

  buf = malloc (BUFS);
  pb = buf + BUFS;
  s = & st [0];
  *s = 0;

  if (*voc) {
    cut_name (voc, vocext);
    unarch (voc);
  } else {
    if ((p = searchpath (vocname)) == NULL) {
      printf ("! NON-STOP: Could not find vocabulary file\n");
      exit (1);
    }
    unarch (p);
  }

  if (wrt) {
    if (!*fname)
      put_date (fname);
    cut_name (fname, textext);
    unlink (fname);
    if ((f = fopen(fname, "wb")) == NULL) {
      printf ("! NON-STOP: Could not open file \"%s\"\n", fname);
      _exit (1);
    }
    getdate (&dt);
    fprintf (f, "(C) RWC Non-Stop\t\t\t\t%i.%i.%i\r\n\r\n",
                 dt.da_day, dt.da_mon, dt.da_year);
  }
  randomize ();
  l = 100;
  highvideo ();
  printf ("\t");

  while (1) {

    c = (char) rand ();

    if (c < 35) {
      if (noone)
        continue;
      l = 1;
/*
                
128                      y    n
  40                     y    n  168
    20                   n    n  188
      20                 n    n  208
        20               n    n  228
          15             y    n  243
            5            n    n  248
              4          n    y  252
                2        y    n  254
                  1      y    n  255
*/
      c = (char) rand ();
      kon = pun = 0;
      noone = 1;
      if (c < 128) {
        *w = '';
        pun = 1;
        goto punc1;
      }
      if (c < 168) {
        *w = '';
        pun = 1;
        goto punc1;
      }
      if (c < 188) {
        *w = '';
        goto punc1;
      }
      if (c < 208) {
        *w = '';
        goto punc1;
      }
      if (c < 228) {
        *w = '';
        goto punc1;
      }
      if (c < 243) {
        *w = '';
        pun = 1;
        goto punc1;
      }
      if (c < 248) {
        *w = '';
        goto punc1;
      }
      if (c < 252) {
        *w = '';
        kon = 1;
        goto punc1;
      }
      if (c < 254) {
        *w = '';
        pun = 1;
        goto punc1;
      }
      *w = '';
      pun = 1;
      goto punc1;
    }

    if (c < 64) {
      l = 2;
      do
        for (t = 0; t < 2; t ++)
          *(w + t) = randch ();
      while (!rs2 (w) || (!isvowel (w) && !isvowel (w + 1)));
      goto punc;
    }

    if (c < 88) {
      l = 3;
      do
        for (t = 0; t < 3; t ++)
          *(w + t) = randch ();
      while (!rs3 (w, 0));
      goto punc;
    }

    if (c > 247)
      l = 5 + ((char) rand ()) / 32;
    else
      l = 4 + ((c - 88) / 40);
    wordgen (l);

punc:

    noone = 0;
    pun = 1;
    kon = 1;

punc1:
    if (beg) {
      beg = 0;
      *w = upc (*w);
    }

    c = (char) rand ();

    if (c < 43 && pun) {
      *(w + l ++) = ',';
      goto writ;
    }
    if (c < 64 && kon && l != 2) {
      *(w + l ++) = '.';
      beg = 1;
      if ((char) rand () > 210)
        abz = 1;
      goto writ;
    }
    if (c < 69 && pun) {
      *(w + l ++) = ';';
      goto writ;
    }
    if (c < 73 && pun) {
      *(w + l ++) = ':';
      goto writ;
    }
    if (c < 76 && pun && l != 2) {
      *(w + l ++) = ' ';
      *(w + l ++) = '-';
      goto writ;
    }
    if (c < 78 && kon && l != 2) {
      *(w + l ++) = '!';
      beg = 1;
      if ((char) rand () > 220)
        abz = 1;
      goto writ;
    }
    if (c < 80 && kon && l != 2) {
      *(w + l ++) = '.';
      *(w + l ++) = '.';
      *(w + l ++) = '.';
      if ((char) rand () > 210)
        abz = 1;
      beg = 1;
    }

writ:
   *(w + l ++) = ' ';
   *(w + l) = 0;
   cprintf ("%s", w);
   strcpy (s + strlen (s), w);
   if (abz) {
     abz = 0;
     printf ("\n\r\t    ");
     lcnt ++;
     if (wrt)
       fprintf (f, "%s\r\n", s);
     memset (s, ' ', 5);
     s [5] = 0;
     continue;
   }
   if (strlen (s) > 55) {
     printf ("\n\t");
     lcnt ++;
     if (wrt)
       fprintf (f, "%s\r\n", s);
     *s = 0;
   }
 }
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */
