/* ------------------------------------------------------ */
/*                  135-Kb RWC Non-Stop                   */
/*              (C) 1992 by OnMind Systems                */
/* ------------------------------------------------------ */

#include <stdio.h>
#include <alloc.h>
#include <process.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <time.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>

#define VOCSIZE ((unsigned long) 4*32*32*32 + 4*3*32*32 + 4*32 + 4)
#define BUFS 32767
#define PVAL(pp) (((unsigned long) *((unsigned *) &pp + 1)) << 4) + ((unsigned) pp)
#define PTRINC if (((unsigned) ptr) == 0xffff)\
		 *((unsigned *) &ptr + 1) += 0x1000;\
	       ((unsigned) ptr) ++

#define MEMCHECK	mem = farcoreleft();

long 			 mem;
FILE                     *f;
int                       vocf;
char huge                *vmax, *v2, *v3;
unsigned long huge       *vm, *v1;
char                     *buf, *pb;
union REGS               r;
char                     *s;
char                     w [35];
unsigned long            lcnt = 1;
short                    wrt = 0, noone = 0;
static char              vocname [12] = "MAIN.RWC";
char                     fname [77];
char                     *vocext = vocname + 5;
char                     textext [] = "TXT";
static char          	 voclabel [] = "RTC 3.1 DataFile (C) 1992 OMS";
time_t tim;
struct tm *timst;          /* Time variables */

/* ------------------------------------------------------ */

void back (void) { putchar ('\r'); clreol (); }

/* ------------------------------------------------------ */

void displ_help (void) {

  printf (
" This is RWC Non-Stop!\n\n"

"   Usage: NON-STOP [vocabulary] [-Ffilename]\n\n"

" Vocabulary: *.RWC (default vocabulary is MAIN).\n"
" If \"filename\" in the -F command is omitted,\n"
" the data-filename (e.g. 08-09-92.TXT) is constructed.\n\n"

" Additional information in file RWC.TXT");
  exit (0);
}

/* ------------------------------------------------------ */

void retype (char *name, char *ext) {

  char *p;

  while (((p = strrchr (name, '.')) == NULL) || *(p - 1) == '.')
    strcpy (name + strlen (name), ".");
  strcpy (++ p, ext);
}

/* ------------------------------------------------------*/

char *put_date (char *s) {

  time (&tim);
  timst = localtime (&tim);
  sprintf (s, "%02u%c%02u%c%02u",
    timst -> tm_mday, '-', timst -> tm_mon + 1, '-', timst -> tm_year);
  return (s);
}

/* ------------------------------------------------------ */

void cut_name (char *name, char *ext) {    /* Cut extra filename symbols */

  char *p;
  int l = 0;

  if (!*name) return;

  if (((p = strrchr (name, '.')) == NULL || *(p + 1) == '\\') && *ext)
						       /* If no extension, */
    retype (name, ext);                                /* set default */

  *(p + 4) = 0;                                        /* cut extension */

  if ((p = strrchr (name, '\\')) == NULL &&
      (p = strrchr (name, ':')) == NULL)
    p = name;
  else p ++;

  while (*p != '.' && *p != 0) {
    p ++;
    l ++;
  }

  if (l > 8)
    memmove (p - (l - 8), p, strlen (p) + 1);
}

/* ------------------------------------------------------ */

void kbcl (void) {

  *((unsigned far *) 0x41al) = *((unsigned far *) 0x41cl);
}

/* ------------------------------------------------------ */

int query (void) {

  r.h.ah = 1;
  int86 (0x16, &r, &r);
  if (!(r.x.flags & 0x40))
    return (r.h.al);
  return (-1);
}


/* ------------------------------------------------------ */

char getvoc (void) {

  if (pb - buf == BUFS)
    read (vocf, pb = buf, BUFS);
  return (*pb ++);
}

/* ------------------------------------------------------ */

void unarch (char *path) {

  register char        c;
  register unsigned long upto;
  char huge  *ptr;
  unsigned long next, crn;
  unsigned step;
  char pro = '1';

  vocf = open (path, O_RDONLY + O_BINARY);

  read (vocf, buf, 29);
  if (memcmp (buf, voclabel, 29)) {
    printf ("! NON-STOP: Bad vocabulary file: %s\n", path);
    exit (1);
  }

  lseek (vocf, 29, SEEK_SET);

  MEMCHECK

  if ((vm = farmalloc (VOCSIZE)) == NULL) {
    puts ("! NON-STOP: Not enough memory");
    exit (1);
  }

  printf ("Loading vocabulary: 0% ");

   (char huge *)            v3 = (char huge *) (vm + 32768l);
   (char huge *)            v2 = (char huge *) (vm + 35840l);
   (unsigned long huge *)   v1 = (unsigned long huge *) (vm + 35872l);
  vmax = (char huge *) (v1 + 1);

  ptr  = (char huge *) vm;
  upto = PVAL(vmax);
  next = PVAL(vm) + (step = (unsigned) (VOCSIZE / 10));

  while (c = getvoc (), (crn = PVAL(ptr)) < upto) {
    if (crn > next) {
      printf ("\b\b\b%c0%%", pro++);
      next += step;
    }
    if (c == 0xff)
      if ((c = getvoc ()) == 0xff)
	*ptr++ = 0xff;
      else {
	c++;
	*ptr = 0;
	PTRINC;
	while (c--) {
	  *ptr = 0;
	  PTRINC;
	}
      }
    else {
      *ptr = c;
      PTRINC;
      if (query () == 27) {
	back ();
	farfree ((void far *) vm);
	exit (0);
      }
      kbcl ();
    }
  }
  printf ("\b\b\b100%%");
  delay (20);
  back ();
}


/* ------------------------------------------------------ */

short isletter (char c) {

 return (
     ((c < 0xf2) && (c > 0xdf)
       ||
      (c < 0xb0) && (c > 0x7f)
     )
 );
}

/* ------------------------------------------------------ */

int isvowel (char *c) {

  switch (*c) {
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
    case '':
      return (1);
    default:
      return (0);
  }
}

/* ------------------------------------------------------ */

int iscons (char *c) {

  if (isletter (*c) && ! isvowel (c))
    return (1);
  return (0);
}

/* ------------------------------------------------------ */

short cr (char c) {

  if ((c == 240) || (c == 241))
    return (5);

  if (c < 160)
    return (c - 128);
  else {
    if (c < 176)
      return (c - 160);
    else return (c - 208);
  }
}

/* ------------------------------------------------------ */

short letters (char *s, char l) {

  while (l --)
    if (!isletter (*(s + l)))
      return (0);
  return (1);
}
/* ------------------------------------------------------ */

unsigned long dw (char *c) {

  return((unsigned long) 1 << cr(*c));
}
/* ------------------------------------------------------ */

short rsmain (char *s) {

  auto unsigned long huge *ptr;

  if (isletter (*s) &&
      isletter (*(s+1)) &&
      isletter (*(s+2)) &&
      isletter (*(s+3))
     ) {
    ptr = vm + (((unsigned long) cr(*s)) << 10) +
	       (((unsigned long) cr(*(s+1))) << 5) +
	       ((unsigned long) cr(*(s+2))) ;
    return ((*ptr & dw (s + 3)) ? 1 : 0);
  }
  return (0);
}

/* ------------------------------------------------------ */

short rs1 (char *s) {

  if (isletter (*s)) {
    return (*v1 & dw (s) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs2 (char *s) {

  auto unsigned long far *ptr;

  if (isletter (*s) &&
      isletter (*(s+1))
     ) {
    ptr = (unsigned long far *)
      ((unsigned long) v2 + (((unsigned long) cr(*s)) << 2));
    return (*ptr & dw (s+1) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs3 (char *s, int ps) {

  auto unsigned long far *ptr;

  if (letters (s, 3)) {
    ptr = (unsigned long far *) (
	      ((unsigned long) v3) +
	     (((unsigned long) ps) << 12) +
	     (((unsigned long) cr(*s)) << 7) +
	     (((unsigned long) cr(*(s+1))) << 2));
    return (*ptr & dw (s+2) ? 1 : 0);
  }
  return (1);
}

/* ------------------------------------------------------ */

char randch (void) {

  char c;

  if ((c = ((char) rand () >> 3)) <= 15)
    return (c + 160);
  return (c + 208);

}

/* ------------------------------------------------------ */

char upc (char c) {

 if (c < 224)
   return (c - 32);
 return (c - 80);
}

/* ------------------------------------------------------ */

void wordgen (char l) {

  char pp, ch, chstart;
  int pause = -1;

b:
  if (query () == 27) {
    if (wrt) {
      fprintf (f, "%s\r\n", s);
      fclose (f);
    }
    farfree ((void far *) vm);
    lowvideo ();
    clreol ();
    exit (0);
  }
  if (query () == 32 || pause > 0 && query () != -1 && query () != 27) {
    pause = -pause;
    kbcl ();
  }
  if (pause > 0)
    goto b;
  kbcl ();

  do {
    w [0] = randch ();
    w [1] = randch ();
    w [2] = randch ();
    w [3] = randch ();
  } while (!rsmain (w) || !rs3 (w, 1));

  pp = 3;
  while (pp++ < l - 1) {
    ch = chstart = randch ();
loop:
    if (++ch > '')
      ch = '';
    if (ch == chstart)
      goto b;

      w [pp] = ch;
      if (rsmain (w + pp - 3))
	goto e;
      goto loop;
e:
    w [l] = 0;
  }
  if (!rs3 (w + l - 3, 2))
    goto b;
}

/* ------------------------------------------------------ */

void main (int argc, char **argv) {

  int /*beg = 1, abz = 0,*/ help = 0;
  register char t;
  char c, l;
  char st [255];
  struct date dt;
  char voc [70];
  char *p;
//  int pun, kon;
  char word [35];

#define		BOS		1l
#define		EOS		(BOS<<1)
#define		NOONE		(EOS<<1)
#define		PUN		(NOONE<<1)
#define		QUOT		(PUN<<1)
#define		BRAK		(QUOT<<1)
#define		ABZ		(BRAK<<1)
#define		WASPUN		(ABZ<<1)
#define         SENTBRAK        (WASPUN<<1)
#define		WASONE		(SENTBRAK<<1)
#define		WASCOLON	(WASONE<<1)
#define		ITAL		(WASCOLON<<1)
#define		WASDIRECT	(ITAL<<1)

#include "xdef.h"

static unsigned long flags = BOS;
static unsigned long old_flags;
static unsigned long old_lastopened, lastopened;

#define PUSHALL		old_flags = flags, old_lastopened = lastopened;
#define POPALL		flags = old_flags, lastopened = old_lastopened;

#define	IMPOSSIBLE	(0)

  *voc = 0;

//  MEMCHECK

  textcolor (LIGHTGRAY);
  textbackground (BLACK);
  printf ("\r  RWC Non-Stop, Version 2.0, Copyright (C) 1992,95 OnMind Systems\n\n");

  for (c = 1; c < argc; c ++) {
    if (**(argv + c) == '-') {
      switch (toupper (*(*(argv + c) + 1))) {
	case '?':
	  help = 1;
	case 'F':
	  wrt = 1;
	  strcpy (fname, *(argv + c) + 2);
	  break;
      }
    }
    else
      strcpy (voc, *(argv + c));
  }

  if (help)
    displ_help ();
  else
    printf ("   Type  NON-STOP -?  for help\n\n");

  buf = malloc (BUFS);
  pb = buf + BUFS;
  s = & st [0];
  *s = 0;

  if (*voc) {
    cut_name (voc, vocext);
    unarch (voc);
  } else {
    if ((p = searchpath (vocname)) == NULL) {
      printf ("! NON-STOP: Could not find vocabulary file\n");
      exit (1);
    }
    unarch (p);
  }

  if (wrt) {
    if (!*fname)
      put_date (fname);
    cut_name (fname, textext);
    unlink (fname);
    if ((f = fopen(fname, "wb")) == NULL) {
      printf ("! NON-STOP: Could not open file \"%s\"\n", fname);
      exit (1);
    }
    getdate (&dt);
    fprintf (f, "(C) RWC Non-Stop\t\t\t\t%i.%i.%i\r\n\r\n",
		 dt.da_day, dt.da_mon, dt.da_year);
  }
  randomize ();
  l = 100;
  highvideo ();
  printf ("\t");


  init_possibilities ();

  PUSHALL;

  while (1) {

    new_cycle ();

    if (flags & BOS && possible (PS_SENTBRAK)) {
      flags |= SENTBRAK;
      strcpy (word, "(");
    }
    else
      strcpy (word, "");

    if ((flags & PUN) && !(flags & WASPUN) && !(flags & ITAL))
      if (!(flags & BOS) && !(flags & BRAK)
		      && !(flags & SENTBRAK) && possible (PS_OBRACKET)) {
	strcat (word, "(");
	init_possibility (X_CBRACKET);
	flags |= BRAK|WASPUN;
	lastopened = BRAK;
      }
      else if (!(flags & QUOT) && possible (PS_OQUOTE)) {
	strcat (word, "<");
	init_possibility (X_CQUOTE);
	flags |= QUOT|WASPUN;
	lastopened = QUOT;
      }

    if (possible (35)) {			// 㪢 ᫮
      if (flags & NOONE) {
	POPALL;
	continue;
      }
      l = 1;

      flags |= NOONE;//noone = 1;
      if (possible (128)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (80) && (flags & WASPUN)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (20)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (20)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (20)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (15)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
	if (flags & BOS)
	  flags |= PUN;
      }
      else if (possible (5)) {
	*w = '';
	flags &= ~(PUN|EOS|WASPUN);
      }
      else if (possible (4)) {
	*w = '';
	flags |= PUN|EOS;//kon = 1;
	flags &= ~WASPUN;
      }
      else if (possible (2) && !(flags & BOS) && !(flags & WASPUN)) {
	*w = '';
	flags |= PUN|EOS;//pun = 1;
      }
      else if (!(flags & BOS) && !(flags & WASPUN)) {
	*w = '';
	if (possible (90))
	  *(w + l++) = '';
	flags |= EOS;//pun = 1;
      }
      else {
	POPALL;
	continue; // ᫨  ᫮  諮 -  横
      }
      flags |= WASONE;
    }
    else if (possible (29)) {  		  	// 㪢 ᫮
      l = 2;
      do
	for (t = 0; t < 2; t ++)
	  *(w + t) = randch ();
      while (!rs2 (w) || (!isvowel (w) && !isvowel (w + 1)));
//      pun = kon = 0;  //   㭪樨   ।
      flags &= ~(PUN|EOS|WASPUN|WASONE);
    }
    else if (possible (24)) {			// 㪢 ᫮
      l = 3;
      do
	for (t = 0; t < 3; t ++)
	  *(w + t) = randch ();
      while (!rs3 (w, 0));
      flags &= ~(NOONE|WASPUN|WASONE);   //noone = 0;
      flags |= (PUN|EOS);//pun = 1; kon = 1;
    }
    else {
      if (possible (18))
	l = 6 + random (8);
      else
	l = 4 + random (4);
      wordgen (l);
      flags &= ~(NOONE|WASONE|WASPUN);   //noone = 0;
      flags |= (PUN|EOS);//pun = 1; kon = 1;
    }

    if (flags & BOS) {
      flags &= ~BOS;//beg = 0;
      *w = upc (*w);
    }
    else if (!(flags & WASONE) && possible (PS_NAME*(l-2)*1.5))
      *w = upc (*w);

    if (!(flags & ITAL) && possible (PS_OITALIC)) {
      strcat (word, "{\\it ");
      flags |= ITAL;
      init_possibility (X_CITALIC);
    }

    if (flags & PUN && !(flags & WASPUN))
      if (possible (PS_COMMA)) {
	*(w + l ++) = ',';
	init_possibility (X_COMMA);
	flags |= WASPUN;
      }
      else if (possible (PS_DASH)) {
	*(w + l ++) = ' ';
	*(w + l ++) = '-';
	init_possibility (X_DASH);
	flags |= WASPUN;
      }
      else if ((flags & QUOT) && lastopened != BRAK && !(flags & ITAL)
			      && possible (PS_CQUOTE)) {
	*(w + l++) = '>';
	flags &= ~QUOT;
	flags |= WASPUN;
	if (flags & BRAK)
	  lastopened = BRAK;
	else
	  lastopened = 0;
	init_possibility (X_OQUOTE);
      }
      else if ((flags & BRAK) && lastopened != QUOT && !(flags & ITAL)
			      && possible (PS_CBRACKET)) {
	*(w + l++) = ')';
	flags &= ~BRAK;
	flags |= WASPUN;
	if (flags & QUOT)
	  lastopened = QUOT;
	else
	  lastopened = 0;
	init_possibility (X_OBRACKET);
      }
      else if ((flags & ITAL) && possible (PS_CITALIC)) {
	*(w + l++) = '}';
	flags &= ~ITAL;
	init_possibility (X_OITALIC);
      }
      else if (possible (PS_SPECIAL)) {
	if (possible (PS_SEMICOLON)) {
	  *(w + l ++) = ';';
	  init_possibility (X_SEMICOLON);
	  flags |= WASPUN;
	}
	else if (!(flags & WASCOLON) && possible (PS_COLON)) {
	  *(w + l ++) = ':';
	  init_possibility (X_COLON);
	  increase_possibility (X_COMMA);
	  advance_possibility (X_COMMADASH);
	  advance_possibility (X_COMMADASH);
	  flags |= WASPUN|WASCOLON;
	}
	else if (!(flags & WASCOLON) && !(flags & WASONE)
			     && possible (PS_DIRECT) && IMPOSSIBLE) {
	  *(w + l ++) = ':';
	  *(w + l ++) = ' ';
	  *(w + l ++) = '<';
	  init_possibility (X_DIRECT);
	  init_possibility (X_CQUOTE);
	  init_possibility (X_COLON);
	  flags |= QUOT|WASPUN|WASCOLON|WASDIRECT;
	  lastopened = QUOT;
	}
	else if (possible (PS_COMMADASH)) {
	  *(w + l ++) = ',';
	  *(w + l ++) = ' ';
	  *(w + l ++) = '-';
	  init_possibility (X_COMMADASH);
	  flags |= WASPUN;
	  if (flags & WASCOLON) {
	    decrease_possibility (X_COMMA);
	    flags &= ~WASCOLON;
	  }
	}
	else {
	  POPALL;
	  continue;
	}
      }
      else if (flags & EOS && !(flags & WASPUN) && possible (PS_EOS)) {    //  ।  直 ⠬ 
	while (lastopened) {
	  if (flags & BRAK && lastopened == BRAK) {
	    *(w + l++) = ')';
	    flags &= ~BRAK;
	    if (flags & QUOT)
	      lastopened = QUOT;
	    else
	      lastopened = 0;
	  }
	  if (flags & QUOT && lastopened == QUOT) {
	    *(w + l++) = '>';
	    flags &= ~QUOT;
	    if (flags & BRAK)
	      lastopened = BRAK;
	    else
	      lastopened = 0;
	  }
	}

	if (possible (PS_POINT)) {
	  *(w + l ++) = '.';
	  init_possibility (X_POINT);
	}
	else if (possible (PS_EXCLAM)) {
	  *(w + l ++) = '!';
	  init_possibility (X_EXCLAM);
	}
	else if (possible (PS_THREEPOINT)) {
	  *(w + l ++) = '.';
	  *(w + l ++) = '.';
	  *(w + l ++) = '.';
	  init_possibility (X_THREEPOINT);
	}
	else if (possible (PS_QUESTION)) {
	  *(w + l ++) = '?';
	  init_possibility (X_QUESTION);
	}
	else {
	  POPALL;
	  continue;
	}
	if (flags & ITAL) {
	  *(w + l++) = '}';
	  flags &= ~ITAL;
	  init_possibility (X_OITALIC);
	}
	if (flags & SENTBRAK) {
	  *(w + l++) = ')';
	  flags &= ~SENTBRAK;
	  init_possibility (X_SENTBRAK);
	}
	if (flags & WASCOLON) {
	  decrease_possibility (X_COMMA);
	  flags &= ~WASCOLON;
	}
	init_possibility (X_EOS);

	flags |= (BOS|WASPUN); //beg = 1;
	flags &= ~(EOS|PUN);
	advance_possibility (X_PARAGRAPH);
	if (possible (PS_PARAGRAPH)) {
	  flags |= ABZ; //abz = 1;
	  init_possibility (X_PARAGRAPH);
	}
      }

//writ:
   if (!(flags & WASDIRECT))
     *(w + l ++) = ' ';
   *(w + l) = 0;
   strcat (word, w);
   cprintf ("%s", word);
   strcat (s, word);
   if (flags & ABZ) {                           // 
     flags &= ~ABZ;//abz = 0;
//     printf ("\r\n':' - %4.2f, ': <' - %4.2f\n\t    ", PS_COLON, PS_DIRECT);
     printf ("\r\n\n\t    ");
     lcnt ++;
     if (wrt)
       fprintf (f, "%s\r\n\r\n", s);
     memset (s, ' ', 5);
     s [5] = 0;
   }
   else if (strlen (s) > 55 && !(flags & WASDIRECT)) {
     printf ("\n\t");
     lcnt ++;
     if (wrt)
       fprintf (f, "%s\r\n", s);
     *s = 0;
   }
   flags &= ~WASDIRECT;
   advance_possibility (X_COMMA     );
   advance_possibility (X_EOS       );
   advance_possibility (X_POINT     );
   advance_possibility (X_THREEPOINT);
   advance_possibility (X_EXCLAM    );
   advance_possibility (X_QUESTION  );
   advance_possibility (X_DASH      );
   advance_possibility (X_COLON     );
//   advance_possibility (X_DIRECT    );
   advance_possibility (X_COMMADASH );
   advance_possibility (X_SEMICOLON );
   advance_possibility (X_OQUOTE    );
   advance_possibility (X_OBRACKET  );
   advance_possibility (X_SENTBRAK  );
   advance_possibility (X_NAME      );
   advance_possibility (X_OITALIC   );
   if (flags & QUOT)
     advance_possibility (X_CQUOTE);
   if (flags & BRAK)
     advance_possibility (X_CBRACKET);
   if (flags & ITAL)
     advance_possibility (X_CITALIC);
   PUSHALL;
 }
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */
