/* ------------------------------------------------------ */
/*                135-Kb Word Constructor                 */
/*              (C) 1992 by OnMind Systems                */
/*           Main module, vocabulary functions            */
/* ------------------------------------------------------ */

#pragma warn -sig

#include <stdio.h>
#include <alloc.h>
#include <process.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <time.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include "\tc\c\rwc\rwcbase.h"
#include "\tc\c\rwc\keys.h"

union REGS rr;

#define VARMAX 8

#define VOCSIZE ((unsigned long) 4*32*32*32 + 4*3*32*32 + 4*32 + 4)
  /* Full vocabulary length */

#define BUFS 2767
  /* Size of vocabulary loading buffer */

#define PVAL(pp) (((unsigned long) *((unsigned *) &pp + 1)) << 4) + ((unsigned) pp)
  /* Absolute value of huge pointer */

#define PTRINC if (((unsigned) ptr) == 0xffff)\
                 *((unsigned *) &ptr + 1) += 0x1000;\
               ((unsigned) ptr) ++
  /* Increment of huge pointer */

static const char *const week [7] =
  {"", "", "", "", "", "", ""};

char filename [45] = "";   /* Current text file name */
char rwcdir [45] = "\\";   /* Current dir */

char *fp, *pup;            /* Current file ptr, top-page ptr */
char *pb, *pend;           /* Top-file, bottom-file ptrs */
int lend;                  /* Last line number */
unsigned fsz;              /* File size */
int lcur, lscr;            /* Current line, current screen line numbers */
int lone;                  /* Flag: New word mode */
int nobli = 0;             /* Flag: Blink paused */
int ederr = 0;             /* Flag: Editor call error occurred */
int touch = 0;             /* Flag: File changed */
unsigned frem;             /* Free memory size */
char *prnhdr;              /* Print header ptr */
int hdrlen;                /* Print header size */
time_t tim;                /* */
struct tm *timst;          /* Time variables */
int ioerr;                 /* Flag: I/O error occurred */

int rsd = 1;               /* Comline flag: check RSD */
int imed = 0;              /* Comline flag: immediate edit */

int i_trans = 0, i_ret;    /* C-T Flags: transfer word, return to CONS */
int t_c = 0;               /* Transfer character */
int note = 1;              /* Flag: not in TEXT */

/* To set via config */

char edname [45] = "";         /* External editor path */
char textext [4] = "TXT";      /* Default textfile extension */
char vocname [45] = "MAIN";    /* Vocabulary filename */
int  tbg = 2;                  /* Text background color */
int  tfg = 0;                  /* Text foreground color (main) */
int  tfg1;                     /* Text foreground color (secondary) */
char textpath [45] = "\\";     /* Creative output path */
int  port = 0;                 /* Printer port number */

int far *video_start;               /* Video memory pointer */
char *vbuf;                         /* Video buffer pointer */

static char        voclabel [] = "RTC 3.1 DataFile (C) 1992 OMS";
char vocext [4] = "RWC";            /* Vocabulary file extension */
int                vocf;            /* Vocfile handle */
char huge          *vmax, *v2, *v3; /* */
unsigned long huge *vm = NULL, *v1; /* Voc partitions ptrs */
char               *buf, *pbuf;     /* Vocfile buffer ptrs */

char               s1 [80], s2 [80], sg [80];  /* CONS work strings */
int                ln, curp;                   /* CONS word length, cur.pos. */
char               vars [VARMAX + 1] [31];     /* Variants storage */
int                varnum = 0;                 /* Variants number */

void interrupt (*oldvec) ();  /* Old CE vector */

#include "\tc\c\rwc\rwcuse.c"
#include "\tc\c\rwc\rwccons.c"
#include "\tc\c\rwc\rwctext.c"

/* ------------------------------------------------------ */

char getvoc (void) {    /* Buffered vocfile read */

  if (pbuf - buf == BUFS)
    read (vocf, pbuf = buf, BUFS);
  return (*pbuf ++);
}

/* ------------------------------------------------------ */

int unarch (int ask) {  /* Load vocabulary */

  register char c;
  register unsigned long upto;
  char vnm [45];                      /* Local filename storage */
  char huge  *ptr;
  unsigned long next, crn;
  unsigned step;
  char pro = '1';

  cur_off ();

  strcpy (vnm, vocname);              /* Old filename */
  pbuf = buf + BUFS;                  /* Reset buffer */

  if (ask || !*vocname) {             /* If no filename, */
ask:
    if (askname (vnm, 1))             /* ask it */
      return (1);
    if (*vnm == 0)                    /* If not entered, */
      return (1);                     /* quit */
  }
  cut_name (vnm, vocext);             /* Civilize filename */

  if (ioerr = 0, (vocf = open (vnm, O_RDONLY + O_BINARY)) == -1 || ioerr) {
    cry (" ᫮  ");
    goto ask;
  }

  read (vocf, buf, 29);
  if (memcmp (buf, voclabel, 29)) {   /* Voclabel does not match */
    cry ("訡  䠩 ᫮");
    close (vocf);
    goto ask;
  }

  lseek (vocf, 29, SEEK_SET);         /* Set to data start */

  dis_work ("㧪 ᫮: 0% ");

  ptr  = (char huge *) vm;
  upto = PVAL(vmax);
  next = PVAL(vm) + (step = (unsigned) (VOCSIZE / 10));

  while (c = getvoc (), (crn = PVAL(ptr)) < upto) {  /* Work loop */
    if (crn > next) {                     /* Refresh progress indicator */
      wwork -> _cr -= 3;
      wprintf (wwork, "%c0%%", pro++);
      next += step;
    }
    if (c == 0xff)
      if ((c = getvoc ()) == 0xff)
        *ptr++ = 0xff;
      else {
        c++;
        *ptr = 0;
        PTRINC;
        while (c--) {
          *ptr = 0;
          PTRINC;
        }
      }
    else {
      *ptr = c;
      PTRINC;
      if (query ()) {                   /* If Esc was pressed, exit */
        quit ();
      }
    }
  }
  wwork -> _cr -= 3;
  wprintf (wwork, "100%%");
  strcpy (vocname, vnm);                /* Affirm filename, */
  vnm [strlen (vnm) - 4] = 0;
  put_name (20, vnm);                   /* put it */
  close (vocf);
  hide_window (wwork);
  return (0);
}

/* ------------------------------------------------------ */

short rsmain (char *s) {       /* ABCD spell-check */

  auto unsigned long huge *ptr;

  ptr = vm + (((unsigned long) cr(*s)) << 10) +
             (((unsigned long) cr(*(s+1))) << 5) +
             ((unsigned long) cr(*(s+2))) ;
  return ((*ptr & dw (s + 3)) ? 1 : 0);
}

/* ------------------------------------------------------ */

short rs1 (char *s) {  /* _A_ spell-check */

  return (*v1 & dw (s) ? 1 : 0);
}

/* ------------------------------------------------------ */

short rs2 (char *s) {  /* _AB_ spell-check */

  auto unsigned long far *ptr;

  ptr = (unsigned long far *)
    ((unsigned long) v2 + (((unsigned long) cr(*s)) << 2));
  return (*ptr & dw (s+1) ? 1 : 0);
}

/* ------------------------------------------------------ */

short rs3 (char *s, int ps) {  /* _ABC_, aBCD_, _ABCd spell-check */

  auto unsigned long far *ptr;

  ptr = (unsigned long far *) (
            ((unsigned long) v3) +
           (((unsigned long) ps) << 12) +
           (((unsigned long) cr(*s)) << 7) +
           (((unsigned long) cr(*(s+1))) << 2));
  return (*ptr & dw (s+2) ? 1 : 0);
}

/* ------------------------------------------------ */

void inc (int pos) {                  /* "Increment" letter */

  register char *c = s2 + pos;

  if (s1 [pos] == '1') {              /* A vowel */
    switch (*c) {
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
      case '':
        *c = ''; break;
    }
  } else if (s1 [pos] == '2') {       /* A consonant */
    (*c) ++;
    if (*c == '')
      *c = '';
    if (*c == '')
      *c = '';
    if (*c == '' || *c == '' || *c == '' || *c == '' || *c == '')
      (*c) ++;
  } else {                            /* Any letter */
    (*c) ++;
    if (*c == 240)
      *c = '';
    if (*c == '')
      *c = '';
  }
}

/* ------------------------------------------------ */

void init (int pos) {                       /* Initial letter set */

  if (s1 [pos] == '1')                      /* A vowel */
    while (!isvow (s2 [pos] = randch ()));
  else if (s1 [pos] == '2')                 /* A consonant */
    while (!iscons (s2 [pos] = randch ()));
  else s2 [pos] = randch ();                /* Any letter */
  sg [pos] = s2 [pos];
}

/* ------------------------------------------------ */

short chk (int pos) {     /* Spell-check up to last-set letter */

  if (ln == 1)
    return (!rs1 (s2));
  if (ln == 2)
    if (pos)
      return (!rs2 (s2));
    else return (0);
  if (pos == 0 || pos == 1)
    return (0);
  if (pos == 2)
    if (ln == 3)
      return (!rs3 (s2, 0));
    else
      return (!rs3 (s2, 1));
  if (pos == ln - 1)
    return (! (rs3 (s2 + ln - 3, 2) && rsmain (s2 + pos - 3)));
  return (!rsmain (s2 + pos - 3));
}

/* ------------------------------------------------ */

int wgen () {     /* Generate word */

  register int t = 0;
  char sh [68];
  clock_t ticks = clock ();

  strcpy (sh, s2);

  if (letters (s1, ln)) {               /* An user's word */
    restore_frame (24, 16);
    return (0);
  }

  if (letters (s2, ln)) {               /* The word has just been made */
    for (; t < ln; t ++)
      if (!isletter (s1 [t]))     /* Increment all letters */
        inc (t);
    t = 0;
  }
  strcpy (sg, s2);                /* Save start form */

again:
  if (!isletter (s2 [t]))
    init (t);
  while (chk (t)) {
incr:
    if (isletter (s1 [t]))
      goto back;
    inc (t);
    if (s2 [t] == sg [t]) {
back:
      t--;
      if (t < 0) {
        restore_frame (24, 16);
        return (1);                     /* Could not imagine such a word */
      }
      goto incr;
    }
  }
  t ++;
  if ((clock () - ticks) > 5) {         /* A noticeable time passed */
    textbackground (BLUE);
    textcolor (WHITE + BLINK);
    gotoxy (75, 24);
    psepri (" Esc ");
  }
  if (query ()) {
    strcpy (s2, sh);
    restore_frame (24, 6);
    return (0);                         /* Interrupted */
  }

  if (t == ln) {
    restore_frame (24, 16);
    return (0);                         /* All done */
  }
  goto again;
}

/* ------------------------------------------------------ */

void main (int argc, char **argv) {

  char c;

  oldvec = getvect (0x24);
  setvect (0x24, ce_handler);        /* Set Critical Error handler */
  ctrlbrk (cb_handler);              /* Set Ctrl-Break handler */
  disp_init ();
  read_conf ();

  for (c = 1; c < argc; c ++) {      /* Parse command line */
    if (**(argv + c) == '-') {       /* Comline key */
      switch (toupper (*(*(argv + c) + 1))) {
        case 'R':
          rsd = 0;
          break;
        case 'E':
          imed = 1;
          break;
      }
    } else
      strcpy (filename, *(argv + c));
  }

  cur_init ();
  cur_off ();
  put_scr ();
  init_win ();

  vbuf = malloc (4000);                      /* Allocate video buffer */
  buf = malloc (BUFS);                       /* Allocate voc buffer */
  frem = (unsigned) min(65535u,coreleft ()); /* Find out free memory */
  pb = malloc (frem);                        /* Allocate memory for text */

  randomize ();

  if ((vm = farmalloc (VOCSIZE)) == NULL) {  /* Allocate vocabulary */
    cry ("筮   ᫮");
    quitting ();
  }
                                             /* Set partition ptrs */
  (char huge *)            v3 = (char huge *) (vm + 32768l);
  (char huge *)            v2 = (char huge *) (vm + 35840l);
  (unsigned long huge *)   v1 = (unsigned long huge *) (vm + 35872l);
  vmax = (char huge *) (v1 + 1);

  if (unarch (0))                            /* Load voc */
    quitting ();

  if (*filename) {                           /* Load text */
    if (t_load (0, 1))
      quitting ();
  } else
    if (t_load (1, 1))
      quitting ();
  c_init ();

  if (imed) {
    t_called (0);                             /* Immediately call editor */
    goto text;
  }

  while (1) {                                 /* The main program loop */
    c_edit ();
text:
    t_edit ();
  }
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */
