/* ------------------------------------------------------ */
/*                135-Kb Word Constructor                 */
/*              (C) 1992 by OnMind Systems                */
/*                 Constructor functions                  */
/* ------------------------------------------------------ */

int wgen ();
int unarch (int);
void t_print ();
void change_name ();
void t_showscr ();
int t_load (int, int);
void t_called (int);
/* ------------------------------------------------------ */

void wpr (char *s, int left) {

  while (*s) {
    putch (*s);
    if (*s == '\n')
      gotoxy (left, wherey ());
    s ++;
  }
}

/* ------------------------------------------------------ */

void set_cur () {

  cur_off ();
  textbackground (BLUE);
  textcolor (LIGHTGRAY);

  gotoxy (8, 22);
  putch (48 + (curp + 1) / 10);
  putch (48 + (curp + 1) % 10);

  gotoxy (12 + curp, 23);
  set_cursor_type (2);
}

/* ------------------------------------------------------ */

void c_draw  () {

  register int t;
  cur_off ();

  textbackground (BLUE);
  textcolor (LIGHTGRAY);
  gotoxy (8, 21);
  putch (48 + ln / 10);
  putch (48 + ln % 10);
  gotoxy (9, 23);
  putch (varnum ? 48 + varnum : ' ');

  gotoxy (12, 21);
  textcolor (WHITE);
  for (t = 0; s1 [t]; t ++)
    if (s1 [t] == '1' || isvow (s1 [t]))
      putch ('-');
    else
      if (s1 [t] == '2' || iscons (s1 [t]))
        putch ('*');
      else
        putch (' ');

  gotoxy (12, 22);
  textbackground (tbg);
  for (t = 0; s1 [t]; t ++)
    if (isletter (s1 [t])) {
      textcolor (tfg);
      putch (s1 [t]);
    } else
      if (isletter (s2 [t])) {
        textcolor (tfg1);
        putch (s2 [t]);
      } else
        putch (' ');
  textbackground (BLUE);
  disp_box ("", 11 + t, 20, 78, 21, LIGHTGRAY, BLUE);

  set_cur ();
}

/* ------------------------------------------------------ */

void c_init () {

  curp = 0;
  ln = 1;
  *s1 = *s2 = '0';
  s1 [1] = s2 [1] = 0;

  c_draw ();
}
/* ------------------------------------------------------ */

void c_left () {

  if (curp > 0)
    curp --;
  set_cur ();
}

void c_right () {

  if (curp < ln)
    curp ++;
  set_cur ();
}

void c_ins () {

  if (ln == 67)
    return;
  memmove (s1 + curp + 1, s1 + curp, ln - curp + 1);
  memmove (s2 + curp + 1, s2 + curp, ln - curp + 1);
  s1 [curp] = s2 [curp] = '0';
  ln ++;
  c_draw ();
}

void c_del () {

  if (ln == 1 || curp == ln)
    return;
  memmove (s1 + curp, s1 + curp + 1, ln - curp + 1);
  memmove (s2 + curp, s2 + curp + 1, ln - curp + 1);
  ln --;
  c_draw ();
}

/* ------------------------------------------------------ */

void fix_word () {

  while (isdigit (s2 [ln - 1]) && ln > 1){
    s2 [-- ln] = 0;     /* Cut end spaces */
    s1 [ln] = 0;
  }
  if (curp > ln)
    curp = ln;
}

/* ------------------------------------------------------ */

void add_var () {

  fix_word ();
  if (strchr (s2, '0') || strchr (s2, '1') || strchr (s2, '2'))
    return;
  if (!memcmp (vars [0], s2, 30) && varnum)
    return;
  memmove (vars [1], vars [0], VARMAX * 31);
  memcpy (vars [0], s2, 30);
  varnum ++;
  if (varnum > VARMAX)
    varnum = VARMAX;
  c_draw ();
}

/* ------------------------------------------------------ */

void var_draw (int pos) {

  int t;

  for (t = 0; t < VARMAX; t ++) {
    disp_box ((t < varnum) ? vars [t] : "", 25, 7 + VARMAX - t, 54, 7 + VARMAX - t,
              BLACK, (t == pos) ? CYAN : LIGHTGRAY);
  }
}

/* ------------------------------------------------------ */

void choose_var () {

  int pos = 0;

  if (varnum == 0)
    return;

  cur_off ();
  clrdis_win (wvar);
  textcolor (BLACK);
  textbackground (LIGHTGRAY);
  gotoxy (27, 8);
  psepri (" ਠ ");
  gotoxy (43, 9 + VARMAX);
  psepri (" Enter / Esc ");

  while (1) {
    var_draw (pos);
    switch (getch ()) {
      case 0:
        switch (getch ()) {
          case LEFT:
          case PGUP:
            pos = varnum - 1;
            break;
          case PGDN:
          case RIGHT:
            pos = 0;
            break;
          case UP:
            if (++ pos == varnum)
              pos = 0;
            break;
          case DOWN:
            if (-- pos < 0)
              pos = varnum - 1;
            break;
          case DEL:
            if (varnum == 1)
              goto del_all;
            if (pos == varnum - 1) {
              pos --;
              varnum --;
              break;
            }
            memmove (vars [pos], vars [pos + 1], 31 * (varnum -- - pos - 1));
            c_draw ();
            break;
          case CTRL_F8:
del_all:
            varnum = 0;
            hide_window (wvar);
            c_draw ();
            return;
        }
        break;
      case ESC:
        hide_window (wvar);
        c_draw ();
        return;
      case ENTER:
        hide_window (wvar);
        strcpy (s1, vars [pos]);
        strcpy (s2, vars [pos]);
        ln = strlen (s1);
        if (curp > ln)
          curp = ln;
        c_draw ();
        return;
    }
  }
}

/* ------------------------------------------------------ */

void c_edit (void) {

  int c;

  swin (0);
  c_draw ();

  if (t_c) {
    c = t_c;
    t_c = 0;
  } else
    c = getch ();
  if (!(c == BACKSPACE || c == ENTER || c == ESC ||
        c == 43 || c == 42 || c == 0))
    c_init ();
  if (c == 0) {
    if (!((c = getch ()) == LEFT || c == RIGHT || c == DEL || c == INS ||
        c == HOME || c == END || (c >= F1 && c <= F10) ||
                                 (c >= CTRL_F1 && c <= ALT_F10)))
      c_init ();
    goto edit0;
  }

  do {
    switch (c) {
      case 0:
        c = getch ();
edit0:
        switch (c) {
          case F6:                /* Transfer to TEXT */
            i_trans = 1;
            i_ret = 0;
            cur_off ();
            return;
          case CTRL_F6:
            i_trans = 1;
            i_ret = 1;
            return;
          case ALT_F6:
            i_trans = 0;
            i_ret = 0;
            cur_off ();
            return;
          case F1:		/* Help */
            cur_off ();
            help (1);
            set_cur ();
            break;
          case F2:
	    t_save ();
	    set_cur ();
            break;
          case ALT_F2:
	    change_name ();
	    set_cur ();
            break;
          case F3:
            t_save ();
            t_load (1, 1);
            set_cur ();
            break;
          case F4:
            t_called (0);
            set_cur ();
            break;
          case ALT_F4:
            t_called (1);
            set_cur ();
            break;
          case F5:
            t_print ();
            set_cur ();
            break;
          case ALT_F5:
            cur_off ();
            t_showscr ();
            set_cur ();
            break;
          case F7:                /* Confirm the word */
            fix_word ();
            strcpy (s1, s2);
            c_draw ();
            break;
          case F8:
            add_var ();
            break;
          case ALT_F8:
            choose_var ();
            break;
          case CTRL_F8:
            varnum = 0;
            c_draw ();
            break;
          case LEFT:
            c_left ();
            break;
          case RIGHT:
            c_right ();
            break;
          case HOME:
            curp = 0;
            set_cur ();
            break;
          case END:
            curp = ln;
            set_cur ();
            break;
          case INS:                               /* Fix letter */
            if (curp == ln || !isletter (s2 [curp]))
              break;
            s1 [curp] = s2 [curp];
            c_right ();
            c_draw ();
            break;
          case DEL:
            if (isletter (s2 [curp])) {		/* Delete letter */
              s1 [curp] = s2 [curp] = '0';
              c_draw ();
            }
            else					/* Delete space */
              c_del ();
            break;
          case F9:
            unarch (1);
            set_cur ();
            break;
          case F10:		/* Exit */
            quit ();
            set_cur ();
            break;
	  case ALT_X:
	    t_save ();
	    quitting ();
        }
        break;
      case BACKSPACE:
        if (curp > 0) {                /* Delete leftward */
          c_left ();
          c_del ();
          if (ln == 1 && curp == 0) {  /* Clear single space */
            *s1 = *s2 = '0';
            c_draw ();
          }
        }
        break;
      case ENTER:			/* Run generator */
        cur_off ();
        if (wgen ()) {
          cry ("! 祣  室  ...");
          strcpy (s2, s1);
        }
        c_draw ();
        break;
      case 42:			/* Vowel/consonant toggle */
        if (isletter (s1 [curp]) || curp == ln)
          break;
        s1 [curp] ++;
        if (s1 [curp] == '3')
          s1 [curp] = '0';
        if (s1 [curp] == '1' && iscons (s2 [curp]) ||
            s1 [curp] == '2' && isvow (s2 [curp]) || isdigit (s2 [curp]))
          s2 [curp] = s1 [curp];
        c_draw ();
        break;
      case 43:			/* Case toggle */
        if (!isletter (s2 [curp]))
          break;
        s1 [curp] = s2 [curp] = toggle (s2 [curp]);
        c_right ();
        c_draw ();
        break;
      case SPACE:			/* Insert space */
        c_ins ();
        c_right ();
        break;
      case ESC:
        if (isletter (s2 [0]) || ln > 1) {  /* Cancel word */
          c_init ();
          break;
        }
        quit ();                  /* Exit */
        set_cur ();
        break;
      default:			/* Any letter key */
        if (!isletter (c) || curp == 67)
          break;
        if (curp == ln)
          c_ins ();
        s1 [curp] = s2 [curp] = c;
        c_right ();
        c_draw ();
        break;
    }
    c = getch ();
  } while (1);
}



