/* ------------------------------------------------------ */
/*                   RWC Mixer Ver 1.0                    */
/*              (C) 1992 by OnMind Systems                */
/* ------------------------------------------------------ */

#pragma warn -pia

#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

#define VOCSIZE ((unsigned long) 4*32*32*32 + 3*4*32*32 + 4*32 + 4)
#define BUFS 32000
#define PVAL(pp) (((unsigned long) *((unsigned *) &pp + 1)) << 4) + ((unsigned) pp)
#define PTRINC if (((unsigned) ptr) == 0xffff)\
                 *((unsigned *) &ptr + 1) += 0x1000;\
               ((unsigned) ptr) ++

int                   vocf;
unsigned long huge   *vm [2], *vmax [2];
char                 perc [2];
char                 *buf, *pb;
int                   plus;
char                  crsst, crsen;
union  REGS           r;

static char           vocname [3] [45];
char                  vocext [4] = "RWC";
static char           voclabel [] = "RTC 3.1 DataFile (C) 1992 OMS";

/* ------------------------------------------------------ */

void cry (char *p) {

  printf (" ! %s\n", p);
  exit (1);
}

void cry1 (char *p, char *fn) {

  printf (" ! %s: \"%s\"\n", p, fn);
  exit (1);
}
/* ------------------------------------------------------ */

void badpar () {

  cry ("訡   ப");
}

/* ------------------------------------------------------ */

void cur_off (void) {

  r.h.ch = 0x20;
  r.h.ah = 1;

  int86 (0x10, &r, &r);
}

/* ------------------------------------------------------ */

void cur_on (void) {

  r.h.ah = 1;
  r.h.ch = crsst;
  r.h.cl = crsen;

  int86 (0x10, &r, &r);
}

/* ------------------------------------------------------ */

void back (void) { putchar ('\r'); clreol (); }

/* ------------------------------------------------------ */

void kbcl (void) {

  *((unsigned far *) 0x41al) = *((unsigned far *) 0x41cl);
}

/* ------------------------------------------------------ */

short query (void) {

  r.h.ah = 1;
  int86 (0x16, &r, &r);
  if (!(r.x.flags & 0x40)) {
    kbcl ();
    if (r.h.al == 27)
      return (1);
  }
  return (0);
}

/* ------------------------------------------------------ */

void backspace (char l) {

  while (l --)
    putchar ('\b');
}

/* ----------------------------------------------------- */

short ask (const char *string) {

  register char c;

  printf ("%s (Y/N) ?", string);
  cur_on ();
  while (1) {
    if  ((c = toupper (getch ())) == 'Y' ||
         c == 132 ||
         c == 164
        ) return (1);
    if  (c == 'N' ||
         c == 27
        ) return (0);
  }
}

/* ------------------------------------------------------ */

void retype (char *name, char *ext) {

  char *p;

  while (!(p = strrchr (name, '.')) || *(p - 1) == '.')
    strcpy (name + strlen (name), ".");
  strcpy (++p, ext);
}

/* ------------------------------------------------------ */

void nem (void) {

  cry ("筮 ");
}

/* ------------------------------------------------------ */

char getvoc (void) {

  if (pb - buf == BUFS)
    _read (vocf, pb = buf, BUFS);
  return (*pb ++);
}

/* ------------------------------------------------------ */

void unarch (int n) {

  register char        c;
  register unsigned long upto;
  char huge  *ptr;
  unsigned long next, crn;
  unsigned step;
  char pro = '1';

  vocf = open (vocname [n], O_RDONLY + O_BINARY);

  read (vocf, buf, 29);
  if (memcmp (buf, voclabel, 29))
    cry1 ("訡  䠩 ᫮", vocname [n]);

  lseek (vocf, 29, SEEK_SET);

  pb = buf + BUFS;
  printf ("㧪 ᫮ %s: 0% ", vocname [n]);

  ptr  = (char huge *) vm [n];
  upto = PVAL(vmax [n]);
  next = PVAL(vm [n]) + (step = (unsigned) (VOCSIZE / 10));

  while (c = getvoc (), (crn = PVAL(ptr)) < upto) {
    if (crn > next) {
      printf ("\b\b\b%c0%%", pro++);
      next += step;
    }
    if (c == 0xff)
      if ((c = getvoc ()) == 0xff)
        *ptr++ = 0xff;
      else {
        c++;
        *ptr = 0;
        PTRINC;
        while (c--) {
          *ptr = 0;
          PTRINC;
        }
      }
    else {
      *ptr = c;
      PTRINC;
      if (query ()) {
        back ();
        exit (0);
      }
    }
  }
  printf ("\b\b\b100%%");
  close (vocf);
  back ();
}

/* ------------------------------------------------------ */

void arch () {

  register char c;
  char huge *ptr = (char huge *) vm [0];
  FILE      *recv;

  recv = fopen (vocname [2], "wb");

  cur_off ();
  fprintf (recv, voclabel);

  back ();
  printf (" ᫮: %s", vocname [2]);

  while (ptr < (char huge *) vmax [0]) {
    if (*ptr == 0)
      if (*++ptr == 0) {
        ptr ++;
        c = 0;
        while ((*ptr == 0) && (c < 0xfe)) {
          PTRINC;
          c ++;
        }
        fputc (0xff, recv);
        fputc (c, recv);
        if (c == 0xfe)
          continue;
      }
      else
        fputc (0, recv);
    if (*ptr == 0xff)
      fputc (0xff, recv);
    fputc (*ptr, recv);
    PTRINC;
  }

  fclose (recv);
  back ();
}

/* ------------------------------------------------------ */

void ending (void) {

  if (ask (" - ࢠ")) {
    cur_on ();
    free (vm [0]);
    free (vm [1]);
    free (buf);
    exit (0);
  }
  backspace (19);
  clreol ();
  cur_off ();
}

/* ------------------------------------------------------ */

void adjust (unsigned long huge *p, char prc) {

  register unsigned long mask = 1;

  for (; mask; mask <<= 1) {
    if (*p & mask)
      if (random (100) > prc)
        *p &= ~mask;
  }
}

/* ------------------------------------------------------ */

void mix () {

  unsigned long huge *p1 = vm [0];
  unsigned long huge *p2 = vm [1];

  printf ("...");

  for (;p1 < vmax [0]; p1 ++, p2 ++) {
    if (perc [0] != 100)
      adjust (p1, perc [0]);
    if (perc [1] != 100)
      adjust (p2, perc [1]);
    if (plus)
      *p1 |= *p2;
    else
      *p1 &= ~*p2;
    if (query ())
      ending ();
  }
  back ();
}

/* ------------------------------------------------------ */

void main (short argc, char **argv) {

  char                  *p, *p2;
  char                   t;
  char arg [255];

  r.h.ah = 0xf;
  int86 (0x10, &r, &r);

  r.h.ah = 3;
  int86 (0x10, &r, &r);
  crsst = r.h.ch;
  crsen = r.h.cl;

  textbackground (BLACK);
  textcolor (LIGHTGRAY);
  cur_off ();
  puts
 ("  RWC Mixer, Version 1.0, Copyright (C) 1992 OnMind Systems\n");

  if (argc < 2) {
    puts ("     ணࠬ 㦨  ࠡ  䠩 ᫮३\n"
          "    ⥬ Russian Word Constructor (Copyright (C) 1992 OMS).\n\n"
          "    맮:\n"
          "    RWCMIX <c-1> [* N1] {+|-} <᫮-2> [* N2] [= <室-᫮>]\n"
          "      -1, 2:   ७ RWC\n"
          "      N1, N2: 業 祭 ᫮३ (1..99,  㬮砭 - 100)\n"
          "      室-᫮:  㬮砭 - ᫮-1\n"
          "\n    쭥 ଠ -  䠩 RWC.DOC");
    cur_on ();
    exit (0);
  }

  p = arg;
  for (t = 1; t < argc; t ++) {
    strcpy (p, *(argv + t));
    *(p += strlen (p)) = ' ';
    p ++;
  }
  *p = 0;


  for (p = arg, t = 0; (*(p + t)) != ' ' &&
                       (*(p + t)) != '*' &&
                       (*(p + t)) != '+' &&
                       (*(p + t)) != '-'; t ++);
  memcpy (vocname [0], p, t);
  *(vocname [0] + t) = 0;
  if (strchr (p, '*') && strchr (p, '*') < max (strchr (p, '+'), strchr (p, '-'))) {
    p = strchr (p, '*');
    while (!isdigit (*p)) {p ++; if (!*p) badpar ();}
    perc [0] = atoi (p);
  } else
    perc [0] = 100;
  if (p = max (strchr (p, '+'), strchr (p, '-')))
    if (*p == '+')
      plus = 1;
    else
      plus = 0;
  else badpar ();

  while (isdigit (*p) || *p == ' ' || *p == '+' || *p == '-') {p ++; if (!*p) badpar ();}
  for (t = 0; (*(p + t)) != ' ' &&
              (*(p + t)) != '*' &&
              (*(p + t)) != '='; t ++);
  memcpy (vocname [1], p, t);
  *(vocname [1] + t) = 0;

  if (strchr (p, '*')) {
    p = strchr (p, '*');
    while (!isdigit (*p)) {p ++; if (!*p) badpar ();}
    perc [1] = atoi (p);
  } else
    perc [1] = 100;

  if (strchr (p, '=')) {
    p = strchr (p, '=');
    while (*p == '=' || *p == ' ') {p ++; if (!*p) badpar ();}
    memcpy (vocname [2], p, t = strchr (p, ' ') - p);
    *(vocname [2] + t) = 0;
  } else
    strcpy (vocname [2], vocname [0]);


  for (t = 0; t < 3; t ++) {
    strupr (vocname [t]);
    retype (vocname [t], vocext);
    if (t != 2)
      if (!searchpath (vocname [t]))
        cry1 ("  䠩 ᫮", vocname [t]);
  }

  buf = malloc (BUFS);
  if (((vm [0] = farmalloc (VOCSIZE)) == NULL) ||
      ((vm [1] = farmalloc (VOCSIZE)) == NULL))
    nem ();

  (unsigned long huge *) vmax [0] = (unsigned long huge *) (vm [0] + 35873l);
  (unsigned long huge *) vmax [1] = (unsigned long huge *) (vm [1] + 35873l);

  unarch (0);
  unarch (1);

  mix ();

  arch ();
  free (vm [0]);
  free (vm [1]);
  free (buf);
  cur_on ();
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */
