/* ------------------------------------------------------ */
/*                135-Kb Word Constructor                 */
/*              (C) 1992 by OnMind Systems                */
/*                     Text functions                     */
/* ------------------------------------------------------ */

/* ------------------------------------------------------ */

unsigned wlen (char *p) {            /* Word length starting from p */

  register int l = 0;

  if (!isletter (*p) || lone)
    return (0);

  while (isletter (*p ++))
    l ++;
  return (l);
}

unsigned slen (char *p) {            /* String length starting from p */

  register int l = 0;

  while (*p ++ != '\r' && p < pend)
    l ++;
  return (l);
}

/* ------------------------------------------------------ */

void disp_line (char *s, int y) {

  register unsigned attr = (tfg + (tbg << 4)) << 8;
  register char *p = s;
  register int far *v = (int far *) (video_start + (y + 2) * 80 + 1);
  int far *ve = v + 76;                   /* (int far *) (video_start + y * 80 + 77); */
  int flag = 1;                            /* string/space switch */
  int bli = 0;

  for (; v <= ve; v ++) {

    if (p == fp && !nobli && !bli) {
      bli = 1;
      if (note)
        attr = (tfg1 + (tbg << 4)) << 8;
      else
        attr |= 0x8000u;
      if (lone) {
        if (ve - v < 3)
          return;
        if (*(p - 1) != ' ' && *(p - 1) != '\n' && p != pb)
          *v ++ = attr | ' ';
        *v ++ = attr | 179;
        *v ++ = attr | ' ';
      } else {
        while (isletter (*p) && v <= ve)
          *v ++ = attr | *p ++;
      }
      attr = (tfg + (tbg << 4)) << 8;
    }

    if (flag && (*p == '\r' || !(*p)))
      flag = 0;                     /* spaces pass */
    if (flag)
      *v = attr | *p ++;
    else
      *v = attr | ' ';
  }
}

/* ------------------------------------------------------ */

int t_pred (char *p) {          /* Finds previous word and sets fp */
                                /* Returns lines passed */
  char *pp = p;
  int inv = 0;
  int l = 0;

  p --;
  while (1) {
    if (isletter (*p) && !inv && p >= pb) {
      inv = 1;
      continue;
    }
    if (inv && (!isletter (*p) || p < pb)) {
      fp = ++ p;
      return (l);
    }
    if (-- p < pb - 1) {
      fp = pp;
      return (0);
    }
    if (*p == '\r')
      l ++;
  }
}

/* ------------------------------------------------------ */

int t_succ (char *p) {          /* Finds next word and sets fp */
                                /* Returns lines passed */
  char *pp = p;
  int inv = 1;
  int l = 0;

  while (p < pend) {
    if ((!isletter (*p) || p < pb) && inv) {
      inv = 0;
      continue;
    }
    if (!inv && (isletter (*p) && p >= pb))
      break;
    if (*p == '\r')
      l ++;
    p ++;
  }
  if (p >= pend) {
    fp = pp;
    return (0);
  }
  fp = p;
  return (l);
}

/* ------------------------------------------------------ */

char *t_home (char *p) {     /* Returns nearest line back from pointer */

  if (p <= pb)
    return (pb);
  if (*p == '\r')
    if (*(p - 1) == '\n')
      return (p);
    else
      p --;
  for (; (*p != '\r') && (p != pb); p --);
  if (*p == '\r')
    p += 2;
  return (p);
}

/* ------------------------------------------------------ */

char *t_end (char *p) {     /* Returns nearest line forward from pointer */

  for (; (*p != '\r') && (p < pend); p ++);
  if (*p == '\r')
    p += 2;
  return (p);
}

/* ------------------------------------------------------ */

int t_line (char *p) {          /* Finds line number from pointer */

  register char *cp = pb;
  register int l = 0;

  while (cp != p) {
    if (*cp == '\r')
      l++;
    cp ++;
  }
  return (l);
}

/* ------------------------------------------------------ */

char *t_point (int line) {     /* Finds pointer from line number */

  register char *cp = pb;
  register int l = 0;

  if (line == 0) return (cp);
  while (l != line) {
    if (cp >= pend)
      return (NULL);
    if (*cp == '\r')
      l ++;
    cp ++;
  }
  return (++ cp);
}

/* ------------------------------------------------------ */

char *t_back (char *p, int l) {     /* Rewinds l lines back from p */

  int ln = 0;

  for (; p >= pb; p --)
    if (*p == '\n')
      if (ln == l)
        return (++ p);
      else
        ln ++;
  return (pb);
}

/* ------------------------------------------------------ */

char *t_pgfor (char *p) {           /* Rewinds 14 lines forward from p */

  int ln = 0;

  for (; p < pend; p++)
    if (*p == '\n') {
      ln ++;
      if (ln == 14)
        return (++ p);
    }
  return (NULL);
}

/* ------------------------------------------------------ */

void t_draw (char *beg) {         /* Puts text into window */

  pup = beg;
  disp_box (beg, 1, 2, 78, 17, tfg, tbg);
  disp_line (t_home (fp), lscr);
  putnum ();
}

/* ------------------------------------------------------ */

int shift () {    /* Returns mean distance of fp from line start */

  return ((fp - t_home (fp)) + 1 + (wlen (fp) >> 1));
}

/* ------------------------------------------------------ */

int t_insw (char *w) {     /* Inserts w at fp */

  int l = strlen (w);

  if ((fsz + l) > frem)
    return (1);

  memmove (fp + l, fp, pend - fp + 1);
  memcpy (fp, w, l);
  fsz += l;
  pend += l;
  touch = 1;
  return (0);
}

/* ------------------------------------------------------ */

int t_replw (char *w) {     /* Replaces current word with w */

  int l = wlen (fp) - strlen (w);

  if ((fsz - l) > frem)
    return (1);

  if (l)
    memmove (fp + strlen (w), fp + strlen (w) + l,
             pend - (fp + wlen (fp)) + 1);
  memcpy (fp, w, strlen (w));
  fsz -= l;
  pend -= l;
  touch = 1;
  return (0);
}

/* ------------------------------------------------------ */

void t_cr () {      /* Inserts \r\n at fp */

  if (t_insw ("\r\n"))
    return;
  fp += 2;
  lend ++;
  lcur ++;
  if (++ lscr > 15) {
    lscr = 15;
    pup = t_end (pup);
  }
  t_draw (pup);
}

/* ------------------------------------------------------ */

void t_moveright () {     /* Moves word right */

  if (fp - t_home (fp) < 77)
    if (!t_insw (" ")) {
      fp ++;
      t_draw (pup);
    }
  return;
}

/* ------------------------------------------------------ */

void t_moveleft () {        /* Moves word left */

  if (fp > pb &&
      *(fp - 1) != '\n' &&
      !isletter (*(fp - 1)) &&
      (!isletter (*(fp - 2)) || fp == pb + 1)
     ) {
    memmove (fp - 1, fp, pend - fp + 1);
    pend --;
    fp --;
    fsz --;
    touch = 1;
    t_draw (pup);
  }
}

/* ------------------------------------------------------ */

void t_delw () {      /* Deletes word or CRLF */

  char *pp = fp;
  int l, up = t_succ (fp);

  if (pp == fp) {
    fp = t_end (pp);
    if (isletter (*pp) && fp != pend) fp -= 2;
    lone = 1;
    goto exec;
  }
  if (up == 0)
    goto exec;
  if (isletter (*pp)) {
    up = 0;
    fp = t_end (pp) - 2;
    lone = 1;
  } else
    if (up == 1) {
      if (*(pp - 1) != ' ')
        *(pp ++) = ' ';
      lone = 0;
    } else {
      fp = t_end (pp);
      up = 1;
      lone = 1;
    }

exec:
  l = fp - pp;
  memmove (pp, fp, pend - fp + 1);
  fp = pp;
  pend -= l;
  lend -= up;
  fsz -= l;
  touch = 1;
  t_draw (pup);
}

/* ------------------------------------------------------ */

void t_delline () {

  char *p1 = t_home (fp);
  char *p2 = t_end (fp);

  if (p1 == p2)
    return;
  memmove (p1, p2, pend - p2 + 1);
  fp = p1;
  pend -= p2 - p1;
  fsz -= p2 - p1;
  lend --;
  touch = 1;
  if (isletter (*fp))
    lone = 0;
  else
    lone = 1;
  t_draw (pup);
}

/* ------------------------------------------------------ */

void t_bksp () {

  char *pp = fp;
  int l, up = t_pred (fp);

  if (pp == fp) {
    fp = t_home (pp);
    if (fp != pb) { fp -=2; up = 1; }
  } else
    if (up != 0) {
      up = 1;
      fp = t_home (pp) - 2;
      if (*(fp - 1) != ' ' && *(fp - 1) != '\n')
        *(fp ++) = ' ';
    }

  l = pp - fp;
  memmove (fp, pp, pend - pp + 1);
  pend -= l;
  lend -= up;
  fsz -= l;
  lcur -= up;
  if ((lscr -= up) < 0) {
    lscr = 0;
    pup = t_home (fp);
  }
  t_draw (pup);
  touch = 1;
}

/* ------------------------------------------------------ */

void t_left () {

  char *p = fp;
  int up = t_pred (fp);
  if (fp == p)
    return;
  lone = 0;

  lcur -= up;

  if (lscr - up < 0) {
    lscr = 0;
    t_draw (t_home (fp));
    return;
  }

  disp_line (t_home (p), lscr);
  if (!up) return;
  disp_line (t_home (fp), lscr -= up);
  putnum ();
}

/* ------------------------------------------------------ */

void t_right () {

  char *p = fp;
  int down = t_succ (fp);

  if (fp == p)
    if (isletter (*fp))
      if (!lone)
        goto endline;
      else
        goto draw;
    else
      return;

  if (lone && isletter (*p)) {
    fp = p;
    down = 0;
  }

  if (down && !lone) {
endline:
    fp = p + wlen (p);
    down = 0;
    lone = 1;
  }
  else {
draw:
    lcur += down;
    lone = 0;
    if (lscr + down > 15) {
      lscr = 15;
      t_draw (t_back (fp, 15));
      return;
    }
  }

  disp_line (t_home (p), lscr);
  if (!down) return;
  disp_line (t_home (fp), lscr += down);
  putnum ();
}

/* ------------------------------------------------------ */

void t_up () {

  char *p = fp, *p1;
  int up = 0;

  p1 = t_home (fp);
  do {
    if (p1 == pb)
      return;
    p1 = t_home (p1 - 3);
    up ++;
  } while (*p1 == '\r');

  up += t_pred (p1 += min(shift (),slen (p1)));

  if (fp == p1) {
    fp = p;
    return;
  }

  lone = 0;
  lcur -= up;

  if (lscr - up < 0) {
    lscr = 0;
    t_draw (t_home (fp));
    return;
  }

  disp_line (t_home (p), lscr);
  if (!up) return;
  disp_line (t_home (fp), lscr -= up);
  putnum ();
}

/* ------------------------------------------------------ */

void t_down () {

  char *p = fp, *p1;
  int down = 0;

  p1 = fp;
  do {
    p1 = t_end (p1);
    if (p1 >= pend)
      return;
    down ++;
  } while (*p1 == '\r');

  if (t_pred (p1 += min(shift (),slen (p1))))
    down += t_succ (-- p1);

  if (fp == p1) {
    fp = p;
    return;
  }

  lone = 0;
  lcur += down;

  if (lscr + down > 15) {
    lscr = 15;
    t_draw (t_back (fp, 15));
    return;
  }

  disp_line (t_home (p), lscr);
  if (!down) return;
  disp_line (t_home (fp), lscr += down);
  putnum ();
}

/* ------------------------------------------------------ */

void t_khome () {

  char *p = fp;

  if (t_succ (t_home (fp) - 1)) {
    fp = p;
    return;
  }
  if (fp < pb) {
    fp = p;
    return;
  }

  lone = 0;
  disp_line (t_home (fp), lscr);
}

/* ------------------------------------------------------ */

void t_kend () {

  fp = t_end (fp);
  if (*(fp - 1) == '\n')
    fp -= 2;
  if (fp < pb)
    fp = pb;
  lone = 1;
  disp_line (t_home (fp), lscr);
}

/* ------------------------------------------------------ */

void t_ins () {

  if (lone)
    return;
  lone = 1;
  disp_line (t_home (fp), lscr);
}

void t_del () {

  if (!lone || !isletter (*fp)) {
    t_delw ();
    return;
  }
  lone = 0;
  disp_line (t_home (fp), lscr);
}

/* ------------------------------------------------------ */

void t_filehome () {

  lone = 0;
  lcur = t_succ (pb - 1);
  if (fp == pb - 1) {
    fp ++;
    lone = 1;
  }
  if (lcur > 14)
    lscr = 0;
  else
    lscr = lcur;
  t_draw (t_back (fp, lscr));
}

/* ------------------------------------------------------ */

void t_fileend () {

  lone = 0;
  lcur = lend;
  t_pred (pend);
  if (fp == pend)
    fp = pb;
  else
    fp += wlen (fp);
  lone = 1;
  lscr = min(14,lend);
  t_draw (t_back (fp, lscr));
}

/* ------------------------------------------------------ */

void t_pgup () {

  char *p = fp, *p1;
  int up = min(14,lcur);

  p1 = t_back (fp, up);

  up += t_pred (p1 += min(shift (),slen (p1)));

  if (fp == p1) {
    fp = p;
    t_filehome ();
    return;
  }

  lone = 0;
  lcur -= up;
  lscr = min(lcur,lscr);
  t_draw (t_back (fp, lscr));
}

/* ------------------------------------------------------ */

void t_pgdown () {

  char *p = fp, *p1;
  int down = 14;

  if ((p1 = t_pgfor (fp)) == NULL) {
    t_fileend ();
    return;
  }

  down -= t_pred (p1 += min(shift (),slen (p1)));

  if (fp == p) {
    t_down ();
    return;
  }

  lone = 0;
  lcur += down;
  lscr = max(lscr,down - (lend - lcur));
  t_draw (t_back (fp, lscr));
}

/* ------------------------------------------------------ */

void t_swap () {

  char st1 [35], st2 [35];
  char *p = fp, *p1;
  int down;

  if (lone) return;

  down = t_succ (fp);
  if (fp == p) return;

  touch = 1;
  memcpy (st1, fp, wlen (fp));
  st1 [wlen (fp)] = 0;
  memcpy (st2, p, wlen (p));
  st2 [wlen (p)] = 0;
  memmove (p + wlen (p) + (wlen (fp) - wlen (p)),
           p + wlen (p), (fp - p) - wlen (p));
  fp += wlen (st1) - wlen (st2);
  memcpy (p, st1, wlen (st1));
  memcpy (fp, st2, wlen (st2));

  p1 = fp; fp = p; p = p1;

  disp_line (t_home (fp), lscr);
  if (!down || lscr + down > 15) return;
  disp_line (t_home (p), lscr + down);
}

/* ------------------------------------------------------ */

void t_showscr () {

  save_scr ();
  disp_box (pup, 0, 0, 79, 24, tfg, tbg);
  if (!getch ()) getch ();
  load_scr ();
}

/* ------------------------------------------------------ */

int istext (void) {

  register char ch;
  register char *p = pb;

  unsigned count, last, eoln;
  unsigned long space, spec;

  if (*pb == 'M' && *(pb + 1) == 'Z')
    return (0);
  count = space = eoln = last = spec = 0;

  do {

    ch = *(p ++);
    switch (ch) {
      case ' ':
      case '\t':
        space ++;
        last = 0;
        break;
      case '\r':
        if (*p ++ == '\n') {
          eoln ++;
          last = 0;
        }
        break;
      default:
        if ((ch >= 0)
            && (ch < 32)
            && (ch != 9)
            && (ch != 26)
            && (ch != '\n')
           )  spec ++;
        last ++;
    }
    if ((last > 28) && (eoln > 0))
      eoln --;
  } while (count ++, p < pend);

  if (spec <= 3)
    spec = 0;
  if (!((space * 17 > count) &&
        ((eoln >= 2) || (spec * 50  < count)) ||
        (eoln >= 7)
       )
     ) return (0);
  return (1);
}

/* ------------------------------------------------------ */

int t_load (int ask, int draw) {

  int f;                              /* Input file handle */
  int lup;                            /* Top screen line number */
  char fnm [45];                      /* Local filename storage */
  unsigned long fs;                   /* Local filesize storage */
  int new = 0;                        /* Flag: new-file */
  int unlo = 0;                       /* Flag: file was unloaded */
  char *pp = fp;

  strcpy (fnm, filename);
  chdir (textpath);

  if (ask) {                          /* If no filename, */
ask:
    new = 0;
    if (*fnm == 0) {                  /* If not yet entered, */
      put_date (fnm, '-');            /* make date-name */
      cut_name (fnm, textext);
    }
    if (askname (fnm, 0)) {           /* ask it */
qui:
      if (unlo && *filename) {
        f = open (filename, O_RDWR + O_TEXT);
        _read (f, pb, fsz);                      /* Restore lost file */
        close (f);
        *(pend = pb + fsz) = 0;                  /* Zero last byte */
      }
      chdir (rwcdir);
      return (1);
    }
    if (*fnm == 0)                    /* If not entered, quit */
      goto qui;
  }
  guess_name (fnm);                   /* Restore full name */
  cut_name (fnm, textext);            /* Civilize filename */

  if (ioerr = 0, (f = open (fnm, O_RDWR + O_TEXT)) == -1) /* If no file, */
    if ((f = _creat (fnm, FA_ARCH)) == -1 || ioerr) {     /* create new */
      cry ("訡  䠩");                               /* Bad name */
      goto ask;
    } else
      new = 1;

  if (!new)
    if ((fs = filelength (f)) > frem) {
      cry ("筮 ");
      close (f);
      goto ask;
    }

  if (new) {                                 /* New file */

    close (f);
    unlink (fnm);
    fs = lcur = lscr = lup = lend = 0;
    pend = fp = pb;
    *pend = 0;
    unlo = 1;

  } else {                                   /* Existing file */

    dis_work (" 䠩...");

    _read (f, pb, (unsigned) fs);                      /* Load file */
    close (f);
    *(pend = pb + (unsigned) fs) = 0;                  /* Zero last byte */
    unlo = 1;

    if (fs > 77)
      if (!istext ()) {
        cry ("⥪⮢ 䠩");
        hide_window (wwork);
        goto ask;
      }

    fp = pend;
    t_pred (pend);                           /* Set fp = last word */
    if (fp == pend) {
      for (fp = pb; fp < pend; fp ++)
        if (isalnum (*fp)) {
          cry ("᪨ ⥪");    /* No Russian word found */
          hide_window (wwork);
          fp = pp;                    /* Restore fp */
          goto ask;
        }
      lscr = lcur = lup = lend = 0;          /* Blank file */
      fp = pb;
      goto end;
    }
    lone = 0;
    fp += wlen (fp);
    lcur = lend = t_line (fp);
    lup = max(0,lcur - 14);
    lscr = lcur - lup;
  }

end:
  fsz = (unsigned) fs;
  strcpy (filename, fnm);

  hide_window (wwork);
  put_name (2, filename);
  lone = 1;                                  /* Set new word mode */
  touch = 0;
  if (draw) t_draw (t_point (lup));          /* Draw screen */
  chdir (rwcdir);
  return (0);
}

/* ------------------------------------------------------ */

int t_save () {

  int tmp;
  char tmppath [45];
  char *p;

  if (!touch)
    return (0);

  chdir (textpath);

  strcpy (tmppath, filename);
  p = max(strrchr (tmppath, '\\'), strrchr (tmppath, ':'));
  if (!p) p = tmppath - 1;
  strcpy (p + 1, "$$rwc$$.tmp");
  if (ioerr = 0, (tmp = _creat (tmppath, FA_ARCH)) == -1 || ioerr)
    goto er;
  if (lseek (tmp, 0, SEEK_SET) == -1L || ioerr)
    goto er;
  if (_write (tmp, pb, fsz) != -1 || (signed) fsz == -1 || ioerr) {
    close (tmp);
    unlink (filename);
    if (rename (tmppath, filename) == -1 || ioerr)
      goto er;
    touch = 0;
    chdir (rwcdir);
    return (0);
  }
er:
  unlink (tmppath);
  ioerr = 0;
  cry ("訡  䠩");
  chdir (rwcdir);
  return (1);
}

/* ------------------------------------------------------ */

void t_called (int ask) {

  int le = lcur;
  int lse = lscr;
  int sh = shift ();
  int lo = lone;
  char *p;
  int up;

  if (t_save ())
    return;
  if (ask || !*edname || ederr)
    if (askname (edname, 2))
      return;
  chdir (textpath);
  save_scr ();
  textbackground (BLACK);
  clrscr ();
  cur_on ();
  if (ioerr = 0, spawnlp (P_WAIT, edname, edname, filename, NULL) == -1 || ioerr) {
    cry ("訡 맮 ।");
    ederr = 1;
    load_scr ();
    chdir (rwcdir);
    return;
  }
  ederr = 0;
  load_scr ();
  cur_off ();
  t_load (0, 0);
  lcur = min(lend,le);
  lscr = min(lend,lse);
  up = t_pred (p = t_point (lcur) + min(slen(t_point(lcur)),sh));
  if (fp == p)
    up = -t_succ (p);
  if (fp == p) {
    lo = 1;
    fp = pb;
  }
  lcur -= up;
  if ((lscr -= up) < 0)
    lscr = 0;
  if (lscr > 14)
    lscr = 14;
  lone = lo;
  t_draw (t_back (fp, lscr));
  chdir (rwcdir);
}

/* ------------------------------------------------------ */

void change_name () {

  char old [45];

  strcpy (old, filename);
  do {
    if (askname (filename, 0)) {
      strcpy (filename, old);
      break;
    }
    cut_name (filename, textext);
    touch = 1;
  } while (t_save ());
  put_name (2, filename);
}

/* ------------------------------------------------------ */

void read_header () {

  FILE *f;
  char c;
  char *p;

  if (ioerr = 0, (f = fopen ("header.prn", "rb")) == NULL || ioerr)
    return;

  fseek (f, 0, SEEK_END);
  if ((p = prnhdr = malloc (hdrlen = max(100, (ftell (f) << 1)))) == NULL)
    return;
  fseek (f, 0, SEEK_SET);

  time (&tim);
  timst = localtime (&tim);

  while (!feof (f)) {
    if ((c = fgetc (f)) == '%')
      switch (c = fgetc (f)) {
        case 'd':
        case 'D':
          put_date (p, '.');
          p += 8;
          break;
        case 't':
        case 'T':
          sprintf (p, "%02d:%02d", timst -> tm_hour, timst -> tm_min);
          p += 5;
          break;
        case 'w':
        case 'W':
          strcpy (p, week [timst -> tm_wday]);
          p += 2;
          break;
        case 'f':
        case 'F':
          strcpy (p, filename);
          if (!strrchr (p, '.'))
            p += strlen (p);
          else
            p = strrchr (p, '.');
          break;
        case 'v':
        case 'V':
          strcpy (p, vocname);
          if (!strrchr (p, '.'))
            p += strlen (p);
          else
            p = strrchr (p, '.');
          break;
        case '%':
          goto put;
      }
    else
put:
      *p ++ = c;
  }
  hdrlen = p - prnhdr - 1;
  fclose (f);
}

/* ------------------------------------------------------ */

int send_pri (char *p, unsigned n) {

  while (n > 0) {
    do {
      if (query ())
        return (0);
      rr.h.ah = 0;
      rr.h.al = *p;
      rr.x.dx = port;
      int86 (0x17, &rr, &rr);
      if (rr.h.ah & 0x08)
        return (1);
    } while (!(rr.h.ah & 0x90) || rr.h.ah & 0x20);
    p ++;
    n --;
  }
  return (0);
}

/* ------------------------------------------------------ */

void t_print () {

  dis_work (" ⥪...");

  if (send_pri ("\x1Bi1", 3))
    goto er;

  read_header ();

  if (prnhdr)
    if (send_pri (prnhdr, hdrlen))
      goto er;

  if (send_pri (pb, fsz))
    goto er;

  hide_window (wwork);
  return;

er:
  cry ("訡 ");
  hide_window (wwork);
}

/* ------------------------------------------------------ */

void t_transw () {

  int l;

  if (!lone) {
    l = wlen (fp);
    memcpy (s2, fp, l);
    s2 [l] = 0;
    memset (s1, '0', l);
    s1 [l] = 0;
    ln = l;
    curp = 0;
  }
}

/* ------------------------------------------------------ */

void t_ret () {

  note = 1;
  disp_line (t_home (fp), lscr);
}

/* ------------------------------------------------------ */

void t_edit () {

  char c;

  if (i_trans) {
    fix_word ();
    if (strchr (s2, '0') || strchr (s2, '1') || strchr (s2, '2'))
      goto ret;
    if (lone) {
      if (fp > pb && *(fp - 1) != ' ' && *(fp - 1) != '\n')
        if (*fp == ' ')
          fp ++;
        else
          t_moveright ();
      strcpy (s2 + strlen (s2), " ");
      t_insw (s2);
      lone = 0;
      s2 [strlen (s2) - 1] = 0;
    } else
      t_replw (s2);
    t_right ();
  }
ret:
  if (i_ret) {
    t_ret ();
    return;
  }

  swin (1);
  note = 0;

loop:
  disp_line (t_home (fp), lscr);
  switch (nobli = 0, c = getch ()) {
    case 0:
      switch (getch ()) {
        case F6:
          t_transw ();
          t_c = 0;
          t_ret ();
          return;
        case ALT_F6:
          t_c = 0;
          t_ret ();
          return;
        case F1:
          help (2);
          break;
        case LEFT:
          t_left ();
          break;
        case RIGHT:
          t_right ();
          break;
        case UP:
          t_up ();
          break;
        case DOWN:
          t_down ();
          break;
        case HOME:
          t_khome ();
          break;
        case END:
          t_kend ();
          break;
        case INS:
          t_ins ();
          break;
        case DEL:
          t_del ();
          break;
        case PGUP:
          t_pgup ();
          break;
        case PGDN:
          t_pgdown ();
          break;
        case CTRL_PGUP:
          t_filehome ();
          break;
        case CTRL_PGDN:
          t_fileend ();
          break;
        case CTRL_LEFT:
          t_moveleft ();
          break;
        case CTRL_RIGHT:
          t_moveright ();
          break;
        case F10:
          quit ();
          break;
	case ALT_X:
	  t_save ();
	  quitting ();
        case F2:
          t_save ();
          break;
        case ALT_F2:
          change_name ();
          break;
        case F3:
          if (t_save ())
            break;
          t_load (1, 1);
          break;
        case F4:
          t_called (0);
          break;
        case ALT_F4:
          t_called (1);
          break;
        case F5:
          t_print ();
          break;
        case ALT_F5:
          t_showscr ();
          break;
        case F9:
          unarch (1);
          break;
        default:
          break;
      }
      goto loop;
    case BACKSPACE:
      t_bksp ();
      break;
    case ENTER:
      t_cr ();
      break;
    case CTRL_S:
      t_swap ();
      break;
    case CTRL_Y:
      t_delline ();
      break;
    case ESC:
      quit ();
      break;
    case SPACE:
      nobli = 1;
      break;
    default:
      if (isletter (c)) {
        t_c = c;
        t_ret ();
        return;
      }
      break;
  }
  goto loop;
}

/* ------------------------------------------------------ */

void read_conf () {

  FILE *f;
  char s [255];
  char *p, *p0;
  int inw;
  int f2 = 0;

  getcurdir (0, rwcdir + 1);
  getcurdir (0, textpath + 1);

  if (ioerr = 0, (f = fopen ("RWC.CFG", "rb")) != NULL && !ioerr) {
    do {
      fgets (s, 255, f);
      if (!strcmp (s + strlen (s) - 2, "\r\n") && strlen (s) >= 2)
	s [strlen (s) - 2] = 0;              /* Cut off CRLF */
      for (p = s, p0 = NULL; *p; p ++)
        if (isletter (*p)) {
	  if (islow (*p)) *p = upc (*p);     /* Uppercase all the line */
	  if (!p0) p0 = p;                   /* Set p0 = keyword start */
        }
      if (!p0) continue;                     /* No keyword - comment line */

      for (p = p0, inw = 1; ((*p == ' ') || (*p == '\t') || inw); p ++)
	if (inw && (*p == ' ' || *p == '\t' || *p == 0))
          inw = 0;

      if (!memcmp (p0, "", 8))
        p0 = edname;
      else if (!memcmp (p0, "", 7))
        p0 = vocname;
      else if (!memcmp (p0, "", 4) && *p)
        p0 = textpath;
      else if (!memcmp (p0, "", 10))
        p0 = textext;
      else if (!memcmp (p0, "", 7)) {
        port = *p - 49;
        if (port < 0 || port > 2)
          port = 0;
        continue;
      }
      else if (!memcmp (p0, "", 3)) {
        tbg = atoi (p);
        if (tbg > 7) tbg = 7;
        continue;
      }
      else if (!memcmp (p0, "1", 5)) {
        tfg = atoi (p);
        if (tfg > 15) tfg = 15;
        continue;
      }
      else if (!memcmp (p0, "2", 5)) {
        tfg1 = atoi (p);
        if (tfg1 > 15) tfg1 = 15;
        f2 = 1;
        continue;
      }
      else continue;

      p [strchr (p, ' ') ? strchr (p, ' ') - p : strlen (p)] = 0;
      strcpy (p0, p);

    } while (!feof(f));

    fclose (f);
  }

  if (!f2) {
    tfg1 = (((tbg > 4) ? 1 : 0) && ((tbg != 7) ? 1 : 0)) + 6;
    tfg1 += ((tfg1 == tfg) ? 1 : 0);
  }
}

/* ------------------------------------------------------ */












