/* ------------------------------------------------------ */
/*                RWC Vocabulator Ver 1.0                 */
/*              (C) 1992 by OnMind Systems                */
/* ------------------------------------------------------ */

#pragma warn -pia

#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

#define VOCSIZE ((unsigned long) 4*32*32*32 + 3*4*32*32 + 4*32 + 4)
#define BUFS 32000
#define PVAL(pp) (((unsigned long) *((unsigned *) &pp + 1)) << 4) + ((unsigned) pp)
#define PTRINC if (((unsigned) ptr) == 0xffff)\
                 *((unsigned *) &ptr + 1) += 0x1000;\
               ((unsigned) ptr) ++

FILE                 *f;
int                   vocf;
char huge            *vmax, *v2, *v3;
unsigned long huge   *vm, *v1;
char                  foname [71];
char                 *inname;
char                 *s, *sp, *hlp;
char                 *buf, *pb;
short                 rus;
short                 cou = 1, disp = 0, ovri = 0;
unsigned              lcnt;
short                 chvoc = 0, tran = 0, ex = 0;
char                  crsst, crsen;
long                  pos;
unsigned long         fsz;
struct ffblk          foundf;
union  REGS           r;

static char           bakext [4] = "BAK";
static char           vocname [45] = "EMPTY";
char                  vocext [4] = "RWC";
static char           voclabel [] = "RTC 3.1 DataFile (C) 1992 OMS";

/* ------------------------------------------------------ */

void cry (char *p) {

  printf (" ! %s\n", p);
  exit (1);
}

void cry1 (char *p, char *fn) {

  printf (" ! %s: \"%s\"\n", p, fn);
  exit (1);
}

/* ------------------------------------------------------ */

void cur_off (void) {

  r.h.ch = 0x20;
  r.h.ah = 1;

  int86 (0x10, &r, &r);
}

/* ------------------------------------------------------ */

void cur_on (void) {

  r.h.ah = 1;
  r.h.ch = crsst;
  r.h.cl = crsen;

  int86 (0x10, &r, &r);
}
/* ------------------------------------------------------ */

void back (void) { putchar ('\r'); clreol (); }

/* ------------------------------------------------------ */

void kbcl (void) {

  *((unsigned far *) 0x41al) = *((unsigned far *) 0x41cl);
}

/* ------------------------------------------------------ */

short query (void) {

  r.h.ah = 1;
  int86 (0x16, &r, &r);
  if (!(r.x.flags & 0x40)) {
    kbcl ();
    if (r.h.al == 27)
      return (1);
  }
  return (0);
}

/* ------------------------------------------------------ */

void backspace (char l) {

  while (l --)
    putchar ('\b');
}

/* ------------------------------------------------------ */

short ispunc (char *c) {

  return (*c == ';'  ||
          *c == ':'  ||
          *c == ','  ||
          *c == '!'  ||
          *c == ')'  ||
          *c == '?'
         );
}

/* ------------------------------------------------------ */

short israzd (char *c) {

  return (ispunc (c) ||
          *c == 0    ||
          *c == ' '  ||
          *c == '\t' ||
          *c == '"'  ||
          *c == '\'' ||
          *c == '('  ||
          *c == '.'  ||
          *c == '-'  ||
          *c == '_'  ||
          *c == '\\' ||
          *c == '/'  ||
          *c == '`'  ||
          *c == '~'
         );
}

/* ------------------------------------------------------ */

short isletter (char *c) {

  return (
    (*c < 0xf2) && (*c > 0xdf)
      ||
    (*c < 0xb0) && (*c > 0x7f)
  );
}

/* ------------------------------------------------------ */

short iscap (char *c) {

  return (*c > 127 && *c < 160);
}

/* ------------------------------------------------------ */

short islow (char *c) {

  return (isletter (c) && !iscap (c));
}

/* ------------------------------------------------------ */

short letters (char *s, char l) {

  while (l --)
    if (!isletter (s + l))
      return (0);
  return (1);
}

/* ------------------------------------------------------ */

unsigned long fsize (FILE *f) {

  auto unsigned long curpos, size;

  curpos = ftell (f);
  fseek (f, 0, SEEK_END);
  size = ftell (f);
  fseek (f, curpos, SEEK_SET);
  return (size);
}

/* ----------------------------------------------------- */

short ask (const char *string) {

  register char c;

  if (string)
    printf (string);
  printf (" (Y/N) ?");
  cur_on ();
  while (1) {
    if  ((c = toupper (getch ())) == 'Y' ||
         c == 132 ||
         c == 164
        ) return (1);
    if  (c == 'N' ||
         c == 27
        ) return (0);
  }
}

/* ------------------------------------------------------ */

void retype (char *name, char *ext) {

  char *p;

  while (!(p = strrchr (name, '.')) || *(p - 1) == '.')
    strcpy (name + strlen (name), ".");
  strcpy (++p, ext);
}

/* ------------------------------------------------------ */

char *fgs (char *p) {

  char *c;

  if (fgets (p, 255, f)) {
    c = p + strlen (p) - 1;
    while (*c == '\n' || *c == '\r')
      *c -- = 0;
    return (p);
  } return (NULL);
}

/* ------------------------------------------------------ */

void nem (void) {

  cry ("筮 ");
}

/* ------------------------------------------------------ */

char getvoc (void) {

  if (pb - buf == BUFS)
    read (vocf, pb = buf, BUFS);
  return (*pb ++);
}

/* ------------------------------------------------------ */

void unarch (char *path) {

  register char        c;
  register unsigned long upto;
  char huge  *ptr;
  unsigned long next, crn;
  unsigned step;
  char pro = '1';

  vocf = open (path, O_RDONLY + O_BINARY);

  read (vocf, buf, 29);
  if (memcmp (buf, voclabel, 29))
    cry1 ("訡  䠩 ᫮", path);

  lseek (vocf, 29, SEEK_SET);

  if (!(vm = farmalloc (VOCSIZE)))
    nem ();

  printf ("㧪 ᫮: 0% ");

   (char huge *)            v3 = (char huge *) (vm + 32768l);
   (char huge *)            v2 = (char huge *) (vm + 35840l);
   (unsigned long huge *)   v1 = (unsigned long huge *) (vm + 35872l);
  vmax = (char huge *) (v1 + 1);

  ptr  = (char huge *) vm;
  upto = PVAL(vmax);
  next = PVAL(vm) + (step = (unsigned) (VOCSIZE / 10));

  while (c = getvoc (), (crn = PVAL(ptr)) < upto) {
    if (crn > next) {
      printf ("\b\b\b%c0%%", pro++);
      next += step;
    }
    if (c == 0xff)
      if ((c = getvoc ()) == 0xff)
        *ptr++ = 0xff;
      else {
        c++;
        *ptr = 0;
        PTRINC;
        while (c--) {
          *ptr = 0;
          PTRINC;
        }
      }
    else {
      *ptr = c;
      PTRINC;
      if (query ()) {
        back ();
        exit (0);
      }
    }
  }
  printf ("\b\b\b100%%");
  close (vocf);
  back ();
}

/* ------------------------------------------------------ */

void arch () {

  register char c;
  char huge *ptr = (char huge *) vm;
  FILE      *recv;

  if (!chvoc)
    return;
  do
    if (!ovri) {
      back ();
      cur_on ();
      printf (" 室 ᫮: ");
      gets (vocname);
      if (*vocname == 0)
        strcpy (vocname, foundf.ff_name);
      retype (strupr (vocname), vocext);
      gotoxy (24, wherey () - 1);
      puts (vocname);
    } else
      ovri = 0;
  while (!(recv = fopen (vocname, "wb")));

  cur_off ();
  fprintf (recv, voclabel);

  back ();
  printf (" ᫮...");

  while (ptr < vmax) {
    if (*ptr == 0)
      if (*++ptr == 0) {
        ptr ++;
        c = 0;
        while ((*ptr == 0) && (c < 0xfe)) {
          PTRINC;
          c ++;
        }
        fputc (0xff, recv);
        fputc (c, recv);
        if (c == 0xfe)
          continue;
      }
      else
        fputc (0, recv);
    if (*ptr == 0xff)
      fputc (0xff, recv);
    fputc (*ptr, recv);
    PTRINC;
  }

  fclose (recv);
  back ();
}
/* ------------------------------------------------------ */

int ones (char byte) {

  register char m;
  int r = 0;

  for (m = 1; m; m <<= 1)
    if (byte & m)
      r ++;
  return (r);
}


/* ----------------------------------------------------- */

short istext (void) {

  long step, count, space, eoln;
  long last, spec, en, ru;
  int ch;

  if (fgetc (f) == 'M' && fgetc (f) == 'Z')
    return (0);
  printf ("- ...");
  pos = 1;
  count = space = eoln = last = spec = en = ru = 0;
  while (count ++, pos < fsz) {
    step = (pos >> 8) + 1;
    step = step * step * step;

    ch = fgetc (f);
    switch (ch) {
      case ' ':
      case '\t':
        space ++;
        last = 0;
        break;
      case '\r':
        if (fgetc (f) == '\n') {
          eoln ++;
          last = 0;
        }
        break;
      case -1: break;
      default:
        if ((ch >= 0)
            && (ch < 32)
            && (ch != 9)
            && (ch != 26)
            && (ch != '\n')
           )  spec ++;
        if (step == 1)
          last++;
        if ((ch > 96) && (ch < 123))
          en ++;
        if (ch > 127 && ch < 176 || ch > 223 && ch < 240)
          ru ++;
    }
    if ((last > 28) && (eoln > 0))
      eoln --;

    pos += step;
    fseek (f, step, SEEK_CUR);
  }

  if (spec <= 3)
    spec = 0;
  backspace (11);
  clreol ();
  if (!((space * 17 > count) &&
        ((eoln >= 2) || (spec * 50  < count)) ||
        (eoln>=7)
       )
     ) return (0);
  rus = (ru > (en << 1));
  rewind (f);
  return (1);
}

/* ------------------------------------------------------ */

short cr (char c) {

  if ((c == 240) || (c == 241))
    return (5);

  if (c < 160)
    return (c - 128);
  else {
    if (c < 176)
      return (c - 160);
    else return (c - 208);
  }
}

/* ------------------------------------------------------ */

unsigned long dw (char *c) {

  return ((unsigned long) 1 << cr(*c));
}

/* ------------------------------------------------------ */

short rsmain (short rd, char *s) {

  auto unsigned long huge *ptr;

  if (letters (s, 4)) {
    ptr = vm + (((unsigned long) cr(*s)) << 10) +
               (((unsigned long) cr(*(s+1))) << 5) +
               ((unsigned long) cr(*(s+2))) ;
    if (rd)
      return ((*ptr & dw (s + 3)) ? 1 : 0);
    if (ex)
      *ptr &= ~dw (s + 3);
    else
      *ptr |= dw (s + 3);
    chvoc = 1;
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs1 (short rd, char *s) {

  if (isletter (s)) {
    if (rd)
      return (*v1 & dw (s) ? 1 : 0);
    if (ex)
      *v1 &= ~dw (s);
    else
      *v1 |= dw (s);
    chvoc = 1;
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs2 (short rd, char *s) {

  auto unsigned long far *ptr;

  if (letters (s, 2)) {
      ptr = (unsigned long far *)
      ((unsigned long) v2 + (((unsigned long) cr(*s)) << 2));
      if (rd)
        return (*ptr & dw (s+1) ? 1 : 0);
    if (ex)
      *ptr &= ~dw (s + 1);
    else
      *ptr |= dw (s + 1);
      chvoc = 1;
  }
  return (1);
}

/* ------------------------------------------------------ */

short rs3 (short rd, char *s, int ps) {

  auto unsigned long far *ptr;

  if (letters (s, 3)) {
      ptr = (unsigned long far *) (
	      ((unsigned long) v3) +
	     (((unsigned long) ps) << 12) +
             (((unsigned long) cr(*s)) << 7) +
             (((unsigned long) cr(*(s+1))) << 2));
      if (rd)
        return (*ptr & dw (s+2) ? 1 : 0);
    if (ex)
      *ptr &= ~dw (s + 2);
    else
      *ptr |= dw (s + 2);
      chvoc = 1;
  }
  return (1);
}

/* ------------------------------------------------------ */

char *home (char *s) {

 register char *ch = s;

 while (*ch == ' ' || *ch == '\t')
   ch ++;

 return (ch);
}

/* ------------------------------------------------------ */

char *ned (char *s) {

  register char *p = s + strlen (s) - 1;

  while (*p == ' ')
    p --;
  return (p);
}

/* ------------------------------------------------------ */

void ending (void) {

  if (ask (" - ࢠ")) {
    cur_off ();
    arch ();
    exit (0);
    cur_on ();
  }
  backspace (19);
  clreol ();
  cur_off ();
}

/* ------------------------------------------------------ */

unsigned long voccount () {

  char huge *ptr = (char huge *) vm;
  unsigned long r = 0;

  cur_off ();
  printf (" ᫮...");

  while (ptr < vmax) {
    if (*ptr != 0) {
      if (query ())
        ending ();
      r += ones (*ptr);
    }
    PTRINC;
  }

  back ();
  return (r);
}

/* ------------------------------------------------------ */

short dow (char *p, char n) {

  while (n -- > 1)
    if (iscap (p + n))
      return (0);
  return (1);
}


/* ------------------------------------------------------ */

short word (char *p, char n) {

  return
    ((p == s || israzd (p - 1)) && !(p == home (s) && tran) &&
     (*(p + n) == 0 || israzd (p + n)) && (*(p + n) != '.') &&
     !((*(p + n) == '-') && isletter (p + n - 1) && (p + n == ned (s))) &&
     dow (p, n)
    );
}

short endw (char *p) {

  return (((p == home (s) && tran) || (p != s && isletter (p - 1)))
          &&  israzd (p + 3)
          && *(p + 3) != '-'               /* dABC_*/
          && dow (p, 3));
}

short begw (char *p) {

  return (!(p == home (s) && tran) && (p != s && israzd (p - 1) || (p == s))
        &&  (isletter (p + 3) || *(p + 3) == '-' && p + 3 == ned (s))
        && dow (p, 3));                    /* _ABCd */
}

/* ------------------------------------------------------ */

void chckln () {

  char *p;

  tran = (*(p = ned (sp)) == '-' && isletter (p - 1));
  for (p = s; *p; p++) {

    if (dow (p, 4))                   /* ABCD */
      rsmain (0, p);

    if (begw (p))
      rs3 (0, p, 1);                  /* _ABCd */

    if (endw (p))
      rs3 (0, p, 2);                 /* dABC_ */

    if (word (p, 3))
      rs3 (0, p, 0);                 /* ABC */

    if (word (p, 2))
      rs2 (0, p);                    /* AB */

    if (islow (p) &&                  /* A */

        (p == s || *(p - 1) == ' ') &&
        (p == ned (s) || *(p + 1) == ' '))
      rs1 (0, p);
  }
}

/* ------------------------------------------------------ */

void filework (void) {

  cur_off ();

  do {
    printf ("\rப %d ", lcnt ++);
    if (query ())
      ending ();
    chckln ();
  } while (hlp = s, s = sp, sp = hlp, fgs (s));

    printf ("\rᥣ ப:\t%d\n", lcnt);

  cur_on ();
}

/* ------------------------------------------------------ */

void main (short argc, char **argv) {

  short                  bak;
  char                  *p;
  char                   t;
  int                    cont = 0;
  int                    perc;
  unsigned long          vc, vc1;
  short                  v0 = 0;

  r.h.ah = 0xf;
  int86 (0x10, &r, &r);

  r.h.ah = 3;
  int86 (0x10, &r, &r);
  crsst = r.h.ch;
  crsen = r.h.cl;

  textbackground (BLACK);
  textcolor (LIGHTGRAY);
  cur_off ();
  puts
 ("  RWC Vocabulator, Version 1.0, Copyright (C) 1992 OnMind Systems\n");

  if (argc < 2) {
    puts ("     ணࠬ 㦨  ࠡ  䠩 ᫮३\n"
          "    ⥬ Russian Word Constructor (Copyright (C) 1992 OMS).\n\n"
          "    맮: RWCVOC <-䠩> [<-᫮>] [<>]\n"
          "      -䠩:  ⥪⮢ 䠩 (⨬ ᨬ *  ?)\n"
          "      -᫮:   ७ RWC ( 㬮砭 EMPTY)\n"
          "      ᮪ :\n"
          "\t-E\t ᪫  宦 ( 㬮砭 - )\n"
          "\t-O\t ९ 室 ᫮\n"
          "\t-S\t ⪫ ᪨ \n"
          "\n    쭥 ଠ -  䠩 RWC.DOC");
    cur_on ();
    exit (0);
  }

  foname [0] = 0;

  for (t = 1; t < argc; t ++) {
    if (**(argv + t) == '-') {
      switch (toupper (*(*(argv + t) + 1))) {
        case 'E':
          ex = 1;
          break;
        case 'S':
          cou = 0;
          break;
        case 'O':
          ovri = 1;
          break;
        default:
          cry ("訡   ப");
      }
    }
    else
      if (!foname [0] && t != 1)
          strcpy (foname, *(argv + t));
  }

  if (foname [0])
    strcpy (vocname, foname);
  else
    v0 = 1;

  retype (vocname, vocext);
  p = searchpath (vocname);

  if (!p)
    cry1 ("  䠩 ᫮", vocname);

  if (cont = findfirst (inname = *(argv + 1), &foundf, 0))
    cry1 ("  ", inname);

  strcpy (foname, inname);

  if (!((s = malloc (225)) && (sp = malloc (255)) &&
        (buf = malloc (BUFS))))
    nem ();
  pb = buf + BUFS;
  unarch (p);
  if (cou)
    if (v0)
      perc = vc = 0;
    else
      perc = (unsigned) (((vc = voccount ()) * 1000) / (VOCSIZE * 8));

  bak = (!strcmp (bakext,
                  strupr (inname) + strlen (inname) - 3));

  while (!cont) {
    if (!strcmp (bakext, foundf.ff_name + strlen (foundf.ff_name) - 3)
       && !bak)
      goto next;

    if (!(p = strrchr (foname, '\\')))
      p = foname;
    else p ++;
    strcpy (p, foundf.ff_name);
    if (!(f = fopen (strupr (foname), "rb")))
      cry1 ("訡 ⥭ 䠩", foname);

    printf ("  : %s ", foname);

    if ((fsz = fsize (f)) < 30) {
      puts ("! ⮩ 䠩");
      goto next;
    }

    if (!istext ()) {
      puts ("! ⥪⮢ 䠩");
      goto next;
    }
    if (!rus) {
      t = !ask ("! , ᪨ ⥪ - த");
      backspace (48);
      clreol ();
      putchar ('\n');
      if (t)
        goto next;
    } else
      putchar ('\n');

    fgs (s);
    *sp = 0;

    lcnt = 1;

    filework ();
    fclose (f);
    goto end;

next:
    fclose (f);
end:
    cont = findnext (&foundf);
  }
  if (cou) {
    printf (" ᫮:   宦 %lu,   %c.%c%c%%\n", vc,
                             (char) (48 + perc / 100),
                             (char) (48 + (perc % 100) / 10),
                             (char) (48 + (perc % 10)));
    perc = (unsigned) (((vc1 = voccount ()) * 1000) / (VOCSIZE * 8));
    printf (" ᫮:    宦 %lu,   %c.%c%c%%\n", vc1,
                             (char) (48 + perc / 100),
                             (char) (48 + (perc % 100) / 10),
                             (char) (48 + (perc % 10)));
    printf ("%s: %li 宦\n", vc1 >= vc ? "" : "᪫", vc1 - vc);
  }
  arch ();
  cur_on ();
}

/* ------------------------------------------------------ */
/*                     That's all...                      */
/* ------------------------------------------------------ */
